Thu Jun 14 14:09:37 EDT 1990

RCS version 4.2 patchlevel 1

The following patches allow the simulator to compile under X11R4, without
resorting to the -DAW_BC backwards compatibility code.  It should still work
under X11R3, but that's now "untested" code, so it may be in error in some
minor way.

Many thanks are due to the various people who submitted patches, most notably
Andreas Stolcke at ICSI, Nigel Goddard at CMU, and Bob Schmid at Commodore.
The original -DAW_BC patch from Stolcke is still available by anonymus FTP,
in the file "pub/simulator/patch.r4bc"; however, I believe that this set of
patches fixes a few more bugs, and, I hope, does not introduce any of its own.

Please report bugs to <simulator-bugs@cs.rochester.edu>.

Liudvikas Bukys
<bukys@cs.rochester.edu>

-------------------------------------------------------------------------------

diff -c -r rcs_dist/README rcs_v4.2/README
*** rcs_dist/README	Mon Oct 30 13:10:53 1989
--- rcs_v4.2/README	Thu Jun 14 14:09:00 1990
***************
*** 1,5 ****
! This is the Rochester Connectionist Simulator (version 4.2); it is
! COPYRIGHT 1989 University of Rochester.
  
  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
--- 1,5 ----
! This is the Rochester Connectionist Simulator (version 4.2 patchlevel 1);
! it is COPYRIGHT 1989 University of Rochester.
  
  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
diff -c -r rcs_dist/README.X11 rcs_v4.2/README.X11
*** rcs_dist/README.X11	Mon Oct 23 11:24:26 1989
--- rcs_v4.2/README.X11	Thu Jun 14 14:07:55 1990
***************
*** 1,8 ****
! Mon Oct 23 11:23:52 EDT 1989
  Liudvikas Bukys
  <bukys@cs.rochester.edu>
  
! Regarding X11 window managers:
  
  	The X11 Graphics Interface has been used successfully with the
  	"uwm" window manager.  Interactions with other window managers
--- 1,15 ----
! [Thu Jun 14 14:07:47 EDT 1990]
  Liudvikas Bukys
  <bukys@cs.rochester.edu>
  
! Regarding X11R4:
! 
! 	As of patch level 1 (see the file include/version.h), the X11
! 	code has been patched to compile for either X11R3 or X11R4.
! 	The R3 code should still work, but has now become untested.
! 
! [Mon Oct 23 11:23:52 EDT 1989]
! Regarding X11R3 window managers:
  
  	The X11 Graphics Interface has been used successfully with the
  	"uwm" window manager.  Interactions with other window managers
diff -c -r rcs_dist/Makefile rcs_v4.2/Makefile
*** rcs_dist/Makefile	Mon Oct 23 10:30:40 1989
--- rcs_v4.2/Makefile	Thu Jun  7 14:31:17 1990
***************
*** 157,169 ****
  	$(MAKE) manpage $(DEFNS)
  	-sh -c 'if test "$(LDCOMPILE)" = "yes"; \
  	then cd src/ld; $(MAKE) CFLAGS="$(LDCOMFLAGS)" SIMDIR="$(SIMDIR)" CC="$(CC)" linker; fi'
- 	cd src; $(MAKE) $(MFLAGS) $(DEFNS) library simtools bp simulator;
- 	-sh -c 'if test "$(WANT_SUN)" = "yes" -a -f $(WANT_SUN_FILE);\
- 	then cd src; $(MAKE) $(MFLAGS) $(DEFNS) sgraphics ; \
- 	fi'
  	-sh -c 'if test "$(WANT_X11)" = "yes" -a -f $(WANT_X11_FILE);\
  	then cd src; $(MAKE) $(MFLAGS) $(DEFNS) xgraphics ;\
  	fi'
  	cd example; $(MAKE) permission
  	$(MAKE) tidy;
  
--- 157,169 ----
  	$(MAKE) manpage $(DEFNS)
  	-sh -c 'if test "$(LDCOMPILE)" = "yes"; \
  	then cd src/ld; $(MAKE) CFLAGS="$(LDCOMFLAGS)" SIMDIR="$(SIMDIR)" CC="$(CC)" linker; fi'
  	-sh -c 'if test "$(WANT_X11)" = "yes" -a -f $(WANT_X11_FILE);\
  	then cd src; $(MAKE) $(MFLAGS) $(DEFNS) xgraphics ;\
  	fi'
+ 	-sh -c 'if test "$(WANT_SUN)" = "yes" -a -f $(WANT_SUN_FILE);\
+ 	then cd src; $(MAKE) $(MFLAGS) $(DEFNS) sgraphics ; \
+ 	fi'
+ 	cd src; $(MAKE) $(MFLAGS) $(DEFNS) library simtools bp simulator;
  	cd example; $(MAKE) permission
  	$(MAKE) tidy;
  
diff -c -r rcs_dist/bin/makesim-dist rcs_v4.2/bin/makesim-dist
*** rcs_dist/bin/makesim-dist	Fri Oct 20 11:44:36 1989
--- rcs_v4.2/bin/makesim-dist	Fri Jun  8 14:45:05 1990
***************
*** 274,279 ****
--- 274,283 ----
  then
  	cflag="$cflag -DTSIM"
  fi
+ if test $xwindows
+ then
+ 	cflag="$cflag -I$xincroot"
+ fi
  
  #_____________________________________________________________________________
  #
***************
*** 505,511 ****
  	simobj="$simobj $giobj"
  	if test $xwindows
  	then
! 		gflag=" -lm -L$xusrlibdir -lXaw -lXmu -lXt -lX11"
  		echo "X11 graphics interface"
  	else
  		gflag=" -lm -lsuntool -lsunwindow -lpixrect"
--- 509,515 ----
  	simobj="$simobj $giobj"
  	if test $xwindows
  	then
! 		gflag=" -lm -L$xusrlibdir -lXaw -lXmu -lXt -lXext -lX11"
  		echo "X11 graphics interface"
  	else
  		gflag=" -lm -lsuntool -lsunwindow -lpixrect"
diff -c -r rcs_dist/example/xgi/BPcontrol.c rcs_v4.2/example/xgi/BPcontrol.c
*** rcs_dist/example/xgi/BPcontrol.c	Tue Oct 10 09:57:17 1989
--- rcs_v4.2/example/xgi/BPcontrol.c	Tue Jun 12 13:19:46 1990
***************
*** 22,31 ****
  #include <X11/Intrinsic.h>
  #include <X11/StringDefs.h>
  #include <X11/Shell.h>
! #include <X11/Box.h>
! #include <X11/Label.h>
! #include <X11/Form.h>
! #include <X11/Scroll.h>
  #include "sim.h"
  #include "bp.h"
  extern Widget gi_tool;
--- 22,38 ----
  #include <X11/Intrinsic.h>
  #include <X11/StringDefs.h>
  #include <X11/Shell.h>
! #ifndef XtSpecificationRelease
! # include <X11/Box.h>
! # include <X11/Label.h>
! # include <X11/Form.h>
! # include <X11/Scroll.h>
! #else
! # include <X11/Xaw/Box.h>
! # include <X11/Xaw/Label.h>
! # include <X11/Xaw/Form.h>
! # include <X11/Xaw/Scrollbar.h>
! #endif /* XtSpecificationRelease */
  #include "sim.h"
  #include "bp.h"
  extern Widget gi_tool;
***************
*** 66,72 ****
  
    sprintf(buf, " %f ", *(cptr->param));
    XtSetValues(cptr->readout, a, 1); /* show value */
!   XtScrollBarSetThumb(cptr->scroll, 1.0-*(cptr->param), 0.05); /* move thumb */
  }
  
  static _control_ptr MakeOneControl(parent, name, param)
--- 73,83 ----
  
    sprintf(buf, " %f ", *(cptr->param));
    XtSetValues(cptr->readout, a, 1); /* show value */
! #ifndef XtSpecificationRelease
!   XtScrollBarSetThumb(cptr->scroll, 1.0-*(cptr->param), 0.05);	/* move thumb */
! #else
!   XawScrollbarSetThumb(cptr->scroll, 1.0-*(cptr->param), 0.05);	/* move thumb */
! #endif /* XtSpecificationRelease */
  }
  
  static _control_ptr MakeOneControl(parent, name, param)
diff -c -r rcs_dist/example/xgi/makefile rcs_v4.2/example/xgi/makefile
*** rcs_dist/example/xgi/makefile	Tue Oct 10 09:57:21 1989
--- rcs_v4.2/example/xgi/makefile	Fri Jun  8 14:33:16 1990
***************
*** 1,4 ****
! all:
  
  838:
  	../../bin/makesim -X -o 838sim 838.c BPcontrol.c
--- 1,4 ----
! all: 838 smiley empty
  
  838:
  	../../bin/makesim -X -o 838sim 838.c BPcontrol.c
diff -c -r rcs_dist/example/xgi/scroll.c rcs_v4.2/example/xgi/scroll.c
*** rcs_dist/example/xgi/scroll.c	Wed Oct 11 07:39:34 1989
--- rcs_v4.2/example/xgi/scroll.c	Tue Jun 12 13:20:31 1990
***************
*** 26,32 ****
  #include <X11/Intrinsic.h>
  #include <X11/StringDefs.h>
  #include <X11/Shell.h>
! #include <X11/Scroll.h>
  #include "sim.h"
  extern Widget gi_tool;
  
--- 26,36 ----
  #include <X11/Intrinsic.h>
  #include <X11/StringDefs.h>
  #include <X11/Shell.h>
! #ifndef XtSpecificationRelease
! # include <X11/Scroll.h>
! #else
! # include <X11/Xaw/Scrollbar.h>
! #endif /* XtSpecificationRelease */
  #include "sim.h"
  extern Widget gi_tool;
  
***************
*** 59,65 ****
                                     scroll_args, XtNumber(scroll_args));
      XtAddCallback(scroll, XtNjumpProc, jump_proc, mte.item.floatval);
      XtPopup(shell, XtGrabNone);           /* popup scrollbar widget, move thumb */
!     XtScrollBarSetThumb(scroll, 1.0-*(mte.item.floatval), 0.05);
      }
    else
  	LOGfprintf(stderr, "MakeControl: '%s' not found\n", argv[1]);
--- 63,74 ----
                                     scroll_args, XtNumber(scroll_args));
      XtAddCallback(scroll, XtNjumpProc, jump_proc, mte.item.floatval);
      XtPopup(shell, XtGrabNone);           /* popup scrollbar widget, move thumb */
! #ifndef XtSpecificationRelease
!     XtScrollBarSetThumb(scroll, 1.0-*(mte.item.floatval), 0.05); 
! #else
!     XawScrollbarSetThumb(scroll, 1.0-*(mte.item.floatval), 0.05);
! #include <X11/Xaw/Scrollbar.h>
! #endif /* XtSpecificationRelease */
      }
    else
  	LOGfprintf(stderr, "MakeControl: '%s' not found\n", argv[1]);
diff -c -r rcs_dist/include/version.h rcs_v4.2/include/version.h
*** rcs_dist/include/version.h	Mon Oct 30 13:11:04 1989
--- rcs_v4.2/include/version.h	Fri Jun  8 11:33:20 1990
***************
*** 3,9 ****
   * Rochester; you should probably not modify them.
   */
  #define RCS_VERSIONSTRING "4.2"
! #define RCS_PATCHLEVEL "0"
  
  /*
   * The local patch level string is defined so that if you make any local
--- 3,9 ----
   * Rochester; you should probably not modify them.
   */
  #define RCS_VERSIONSTRING "4.2"
! #define RCS_PATCHLEVEL "1"
  
  /*
   * The local patch level string is defined so that if you make any local
***************
*** 11,17 ****
   * at the appropriate times when the program identified itself.
   * The University of Rochester will generally define this as the null
   * string, leaving it to other sites to define it to whatever they wish.
!  * We recommend setting it to something like "/1" for your first local patch.
   * Or, perhaps, "/sitename/1".  I hope you get the idea.
   */
  #define RCS_LOCALPATCHLEVEL ""
--- 11,17 ----
   * at the appropriate times when the program identified itself.
   * The University of Rochester will generally define this as the null
   * string, leaving it to other sites to define it to whatever they wish.
!  * I recommend setting it to something like "/1" for your first local patch.
   * Or, perhaps, "/sitename/1".  I hope you get the idea.
   */
  #define RCS_LOCALPATCHLEVEL ""
diff -c -r rcs_dist/src/xgi/Display.c rcs_v4.2/src/xgi/Display.c
*** rcs_dist/src/xgi/Display.c	Tue Sep 26 14:11:27 1989
--- rcs_v4.2/src/xgi/Display.c	Tue Jun 12 12:45:08 1990
***************
*** 27,33 ****
  #include <X11/IntrinsicP.h>
  #include <X11/Xlib.h>
  #include <X11/StringDefs.h>
! #include <X11/List.h>
  #include <X11/Shell.h>
  #include "DisplayP.h"
  #include "macros.h"
--- 27,37 ----
  #include <X11/IntrinsicP.h>
  #include <X11/Xlib.h>
  #include <X11/StringDefs.h>
! #ifndef XtSpecificationRelease
! # include <X11/List.h>
! #else
! # include <X11/Xaw/List.h>
! #endif /* XtSpecificationRelease */
  #include <X11/Shell.h>
  #include "DisplayP.h"
  #include "macros.h"
***************
*** 281,295 ****
       Cardinal* num_params;
  
  {
-   XWindowAttributes atts;
-   Widget temp;
-   Position x,y;
    int menu;
! 
! 				/* get display window location */
    XGetWindowAttributes(XtDisplay(gi_tool), XtWindow(XtParent(XtParent(XtParent(w)))), &atts);
    x = (buttonx = event->xbutton.x) + atts.x;	/* add in button location */
    y = (buttony = event->xbutton.y) + atts.y;
  
    if (*num_params != 1)
      {
--- 285,308 ----
       Cardinal* num_params;
  
  {
    int menu;
!   Position x,y;
! #ifdef oldstuff
!   XWindowAttributes atts;
    XGetWindowAttributes(XtDisplay(gi_tool), XtWindow(XtParent(XtParent(XtParent(w)))), &atts);
    x = (buttonx = event->xbutton.x) + atts.x;	/* add in button location */
    y = (buttony = event->xbutton.y) + atts.y;
+ #else
+   Window root, child;
+   int root_x, root_y, child_x, child_y;
+   unsigned int buttons;
+   XQueryPointer(XtDisplay(gi_tool), XtWindow(w), &root, &child,
+ 			  &root_x, &root_y, &child_x, &child_y, &buttons);
+   buttonx = event->xbutton.x;
+   buttony = event->xbutton.y;
+   x = root_x;
+   y = root_y;
+ #endif
  
    if (*num_params != 1)
      {
***************
*** 379,385 ****
  static void do_x_menu_item(w, menu, item)
       Widget w;
       int menu;			/* menu number */
!      XtListReturnStruct * item;	/* item */
       
  {
    menu_item_ptr mitemptr;
--- 392,402 ----
  static void do_x_menu_item(w, menu, item)
       Widget w;
       int menu;			/* menu number */
! #ifndef XtSpecificationRelease
!      XtListReturnStruct * item;		/* item */
! #else
!      XawListReturnStruct * item;	/* item */
! #endif /* XtSpecificationRelease */
       
  {
    menu_item_ptr mitemptr;
***************
*** 464,470 ****
    menu_item_ptr mptr;
    char colon[128];
  
!   str = XtDialogGetValueString(editdialog);
    if (sscanf(str, "%s %s ", name, colon) != 2 || strcmp(colon,":"))
      {
        gi_put_error("Wrong syntax! Use \"name : command\"");
--- 481,491 ----
    menu_item_ptr mptr;
    char colon[128];
  
! #ifndef XtSpecificationRelease
!   str =  XtDialogGetValueString(editdialog);
! #else
!   str =  XawDialogGetValueString(editdialog);
! #endif /* XtSpecificationRelease */
    if (sscanf(str, "%s %s ", name, colon) != 2 || strcmp(colon,":"))
      {
        gi_put_error("Wrong syntax! Use \"name : command\"");
***************
*** 523,529 ****
      }
    else
      menu_items[edit_menu][edit_item] = unused;
!   XtListChange(current_menu, menu_items[edit_menu], ITEMS_PER_MENU, 0, False);
  
   gout:
    XtDestroyWidget(editpopup);
--- 544,554 ----
      }
    else
      menu_items[edit_menu][edit_item] = unused;
! #ifndef XtSpecificationRelease
!   XtListChange(current_menu, menu_items[edit_menu], ITEMS_PER_MENU, 0, False); 
! #else
!   XawListChange(current_menu, menu_items[edit_menu], ITEMS_PER_MENU, 0, False);
! #endif /* XtSpecificationRelease */
  
   gout:
    XtDestroyWidget(editpopup);
***************
*** 543,549 ****
  static void do_item_edit(w, menu, item)
       Widget w;
       int menu;			/* menu number */
!      XtListReturnStruct * item;	/* item */
       
  {
    menu_item_ptr mitemptr;
--- 568,578 ----
  static void do_item_edit(w, menu, item)
       Widget w;
       int menu;			/* menu number */
! #ifndef XtSpecificationRelease
!      XtListReturnStruct * item;		/* item */
! #else
!      XawListReturnStruct * item;	/* item */
! #endif /* XtSpecificationRelease */
       
  {
    menu_item_ptr mitemptr;
***************
*** 557,562 ****
--- 586,592 ----
        { XtNy, (XtArgVal) 0 },
        { XtNwidth, (XtArgVal) 0 },
        { XtNheight, (XtArgVal) 70 },
+       { XtNinput, (XtArgVal) True },
      };
    static Arg d[] = 
      {
diff -c -r rcs_dist/src/xgi/Makefile rcs_v4.2/src/xgi/Makefile
*** rcs_dist/src/xgi/Makefile	Tue Sep 19 12:02:41 1989
--- rcs_v4.2/src/xgi/Makefile	Tue Jun 12 13:23:19 1990
***************
*** 16,22 ****
  #				 don't ask about the escape sequences!!
  #				 all I want is -DXX='"YY"' passed to cc
  #
! FLAGS = $(CFLAGS) -I$(IDIR) -I$(XINCROOT)
  #
  RFLAGS= $(FLAGS) -DXGIDIR='"'"'$(RELDIR)'"'"' -O 
  #
--- 16,22 ----
  #				 don't ask about the escape sequences!!
  #				 all I want is -DXX='"YY"' passed to cc
  #
! FLAGS = $(CFLAGS) -I$(IDIR) -I$(XINCROOT) -Dindex=list_index
  #
  RFLAGS= $(FLAGS) -DXGIDIR='"'"'$(RELDIR)'"'"' -O 
  #
diff -c -r rcs_dist/src/xgi/Xsupport.c rcs_v4.2/src/xgi/Xsupport.c
*** rcs_dist/src/xgi/Xsupport.c	Tue Sep 26 14:01:03 1989
--- rcs_v4.2/src/xgi/Xsupport.c	Tue Jun 12 12:46:09 1990
***************
*** 15,24 ****
  
  /* Xsupport.c */
  #include "Xsupport.h"
! #include <X11/Box.h>
! #include <X11/Command.h>
! #include <X11/VPaned.h>
! #include <X11/AsciiText.h>
  #include <X11/Xlib.h>
  
  extern XFontStruct gi_default_font;
--- 15,31 ----
  
  /* Xsupport.c */
  #include "Xsupport.h"
! #ifndef XtSpecificationRelease
! # include <X11/Box.h>
! # include <X11/Command.h>
! # include <X11/VPaned.h>
! # include <X11/AsciiText.h>
! #else
! # include <X11/Xaw/Box.h>
! # include <X11/Xaw/Command.h>
! # include <X11/Xaw/Paned.h>
! # include <X11/Xaw/AsciiText.h>
! #endif /* XtSpecificationRelease */
  #include <X11/Xlib.h>
  
  extern XFontStruct gi_default_font;
***************
*** 92,98 ****
    /* count the number of buttons */
    for(c=0; b[c]!=NULL; c++);
    
!   radio_box=XtCreateManagedWidget(s, formWidgetClass, w, no_bdr, 1);
    buttons = (button_list *) malloc (sizeof(button_list));
    buttons->toggle_list = toggle_list = (Widget *) malloc (c * sizeof (Widget));
    buttons->count = c;
--- 99,105 ----
    /* count the number of buttons */
    for(c=0; b[c]!=NULL; c++);
    
!   radio_box=XtCreateManagedWidget(s, formWidgetClass, w, no_bdr, XtNumber(no_bdr));
    buttons = (button_list *) malloc (sizeof(button_list));
    buttons->toggle_list = toggle_list = (Widget *) malloc (c * sizeof (Widget));
    buttons->count = c;
***************
*** 241,251 ****
  {
  	Arg *a;
  	Widget ret;
  
  #ifdef DEBUG
  	printf("Xsupport: creating widget named %s.\n",n);
  #endif
!   a = (Arg *)malloc(10*sizeof(Arg));
    if (a == NULL)
      {
        error2("!AddTextEdit(%s): couldn't allocate space for args!\n.",s);
--- 248,259 ----
  {
  	Arg *a;
  	Widget ret;
+ 	int i;
  
  #ifdef DEBUG
  	printf("Xsupport: creating widget named %s.\n",n);
  #endif
!   a = (Arg *)malloc(16*sizeof(Arg)), i = 0;
    if (a == NULL)
      {
        error2("!AddTextEdit(%s): couldn't allocate space for args!\n.",s);
***************
*** 252,273 ****
        exit(1);
      }
  
!   XtSetArg(*a, XtNstring, (XtArgVal)s);
!   XtSetArg(*(a+1), XtNeditType, (XtArgVal)XttextEdit);
!   XtSetArg(*(a+2), XtNwidth, (XtArgVal) (v*6)); /* assume char = 6 pix */
!   XtSetArg(*(a+3), XtNheight, (XtArgVal)20);
!   XtSetArg(*(a+4), XtNlength, (XtArgVal) l);
!   XtSetArg(*(a+5), XtNhorizDistance, (XtArgVal)20);
!   XtSetArg(*(a+6), XtNfromHoriz, (XtArgVal) p);
!   if (l > v)
!     XtSetArg(*(a+7), XtNtextOptions, (XtArgVal)(editable|scrollHorizontal));
!   else
!     XtSetArg(*(a+7), XtNtextOptions, (XtArgVal)(editable|scrollOnOverflow));
!   XtSetArg(*(a+8), XtNborderWidth, (XtArgVal) 0);
!   XtSetArg(*(a+9), XtNfont, (XtArgVal) &gi_default_font);
  
!   ret =  XtCreateManagedWidget(n, asciiStringWidgetClass, w, a, 10);
!   XtTextSetInsertionPoint(ret, strlen(XtNstring));
    free(a);
    return (ret);
  }
--- 260,286 ----
        exit(1);
      }
  
!   XtSetArg(a[i], XtNstring, (XtArgVal)s), i++;
!   XtSetArg(a[i], XtNwidth, (XtArgVal) (v*6)), i++; /* assume char = 6 pix */
!   XtSetArg(a[i], XtNheight, (XtArgVal)20), i++;
!   XtSetArg(a[i], XtNlength, (XtArgVal) l), i++;
!   XtSetArg(a[i], XtNhorizDistance, (XtArgVal)20), i++;
!   XtSetArg(a[i], XtNfromHoriz, (XtArgVal) p), i++;
!   XtSetArg(a[i], XtNborderWidth, (XtArgVal) 0), i++;
!   XtSetArg(a[i], XtNfont, (XtArgVal) &gi_default_font), i++;
  
! #ifndef XtSpecificationRelease
!   XtSetArg(a[i], XtNeditType, (XtArgVal)XttextEdit), i++;
!   ret =  XtCreateManagedWidget(n, asciiStringWidgetClass, w, a, i);
!   XtTextSetInsertionPoint(ret, strlen(s)); 
! #else
!   XtSetArg(a[i], XtNuseStringInPlace, (XtArgVal) True), i++;
!   XtSetArg(a[i], XtNeditType, (XtArgVal)XawtextEdit), i++;
!   XtSetArg(a[i], XtNtype, (XtArgVal) XawAsciiString), i++;
!   ret =  XtCreateManagedWidget(n, asciiTextWidgetClass, w, a, i);
!   XawTextSetInsertionPoint(ret, strlen(s));
! #endif /* XtSpecificationRelease */
! 
    free(a);
    return (ret);
  }
***************
*** 318,324 ****
  	printf("Xsupport: creating widget named %s.\n",name);
  #endif
  
!   return(XtCreateManagedWidget(name, vPanedWidgetClass, parent, NULL, 0));
  }
- 
- 
--- 331,339 ----
  	printf("Xsupport: creating widget named %s.\n",name);
  #endif
  
! #ifndef XtSpecificationRelease
!   return( XtCreateManagedWidget(name, vPanedWidgetClass, parent, NULL, 0) );
! #else
!   return( XtCreateManagedWidget(name, panedWidgetClass, parent, NULL, 0) );
! #endif /* XtSpecificationRelease */
  }
diff -c -r rcs_dist/src/xgi/Xsupport.h rcs_v4.2/src/xgi/Xsupport.h
*** rcs_dist/src/xgi/Xsupport.h	Tue Sep 26 14:01:05 1989
--- rcs_v4.2/src/xgi/Xsupport.h	Tue Jun 12 13:26:16 1990
***************
*** 17,24 ****
  #include <stdio.h>
  #include <X11/Intrinsic.h>
  #include <X11/StringDefs.h>
! #include <X11/Dialog.h>
! #include <X11/Text.h>
  
  #define error1(x) fprintf(stderr,x)
  #define error2(x,y) fprintf(stderr,x,y)
--- 17,30 ----
  #include <stdio.h>
  #include <X11/Intrinsic.h>
  #include <X11/StringDefs.h>
! 
! #ifndef XtSpecificationRelease
! # include <X11/Dialog.h>
! # include <X11/Text.h>
! #else
! # include <X11/Xaw/Dialog.h>
! # include <X11/Xaw/Text.h>
! #endif /* XtSpecificationRelease */
  
  #define error1(x) fprintf(stderr,x)
  #define error2(x,y) fprintf(stderr,x,y)
diff -c -r rcs_dist/src/xgi/cmd_panel.c rcs_v4.2/src/xgi/cmd_panel.c
*** rcs_dist/src/xgi/cmd_panel.c	Mon Oct 23 13:45:26 1989
--- rcs_v4.2/src/xgi/cmd_panel.c	Tue Jun 12 13:32:38 1990
***************
*** 32,42 ****
  #include "control_panel.h"
  #include "mode_panel.h"
  #include "info_panel.h"
! #include <X11/AsciiText.h>
! #include <X11/Text.h>
! #include <X11/Box.h>
! #include <X11/Xmu.h>
! #include <X11/Label.h>
  
  /* these defines are for the gi_parse State machine */
  #define START_STATE   0
--- 32,50 ----
  #include "control_panel.h"
  #include "mode_panel.h"
  #include "info_panel.h"
! #ifndef XtSpecificationRelease
! # include <X11/AsciiText.h>
! # include <X11/Text.h>
! # include <X11/Box.h>
! # include <X11/Xmu.h>
! # include <X11/Label.h>
! #else
! # include <X11/Xaw/AsciiText.h>
! # include <X11/Xaw/Text.h>
! # include <X11/Xaw/Box.h>
! # include <X11/Xmu/Xmu.h>
! # include <X11/Xaw/Label.h>
! #endif /* XtSpecificationRelease */
  
  /* these defines are for the gi_parse State machine */
  #define START_STATE   0
***************
*** 75,82 ****
  		{ XtNstring, (XtArgVal) cmd_item_buf},
  		{ XtNlength, (XtArgVal) MAX_CMD_LENGTH - 3},
  		{ XtNborderWidth, (XtArgVal) 0 },
! 		{ XtNeditType, (XtArgVal) XttextEdit},
! 		{ XtNtextOptions, (XtArgVal)(editable | scrollOnOverflow | wordBreak) },
  		{ XtNheight, (XtArgVal)40 },
  		{ XtNfont, (XtArgVal) &gi_default_font },
  };
--- 83,98 ----
  		{ XtNstring, (XtArgVal) cmd_item_buf},
  		{ XtNlength, (XtArgVal) MAX_CMD_LENGTH - 3},
  		{ XtNborderWidth, (XtArgVal) 0 },
! #ifndef XtSpecificationRelease
! 		{ XtNeditType,  (XtArgVal) XttextEdit},
! 		{ XtNtextOptions,  (XtArgVal)(editable | scrollOnOverflow | wordBreak) },
! #else
! 		{ XtNuseStringInPlace,  (XtArgVal) True },
! 		{ XtNtype,  (XtArgVal) XawAsciiString },
! 		{ XtNeditType,  (XtArgVal) XawtextEdit},
! 		{ XtNwrap,  (XtArgVal) XawtextWrapWord },
! 		{ XtNscrollVertical,  (XtArgVal) XawtextScrollWhenNeeded },
! #endif /* XtSpecificationRelease */
  		{ XtNheight, (XtArgVal)40 },
  		{ XtNfont, (XtArgVal) &gi_default_font },
  };
***************
*** 83,92 ****
  static Arg cmd_prev_item_args[] = {
  		{ XtNfromHoriz, (XtArgVal)NULL },
  		{ XtNwidth, (XtArgVal)400 },
- 		{ XtNfile, (XtArgVal) filenamebuf },
  		{ XtNhorizDistance, (XtArgVal)10 },
! 		{ XtNeditType, (XtArgVal)XttextAppend},
! 		{ XtNtextOptions, (XtArgVal) (scrollVertical | wordBreak)},
  		{ XtNlength, (XtArgVal) MAX_CMD_LENGTH},
  		{ XtNheight, (XtArgVal)60 },
  		{ XtNfont, (XtArgVal) &gi_default_font },
--- 99,116 ----
  static Arg cmd_prev_item_args[] = {
  		{ XtNfromHoriz, (XtArgVal)NULL },
  		{ XtNwidth, (XtArgVal)400 },
  		{ XtNhorizDistance, (XtArgVal)10 },
! #ifndef XtSpecificationRelease
! 		{ XtNfile,  (XtArgVal) filenamebuf },
! 		{ XtNeditType,  (XtArgVal)XttextAppend},
! 		{ XtNtextOptions,  (XtArgVal) (scrollVertical | wordBreak)},
! #else
! 		{ XtNstring,  (XtArgVal) filenamebuf },
! 		{ XtNtype,  (XtArgVal) XawAsciiFile },
! 		{ XtNeditType,  (XtArgVal)XawtextAppend},
! 		{ XtNwrap,  (XtArgVal) XawtextWrapWord },
! 		{ XtNscrollVertical,  (XtArgVal) XawtextScrollAlways },
! #endif /* XtSpecificationRelease */
  		{ XtNlength, (XtArgVal) MAX_CMD_LENGTH},
  		{ XtNheight, (XtArgVal)60 },
  		{ XtNfont, (XtArgVal) &gi_default_font },
***************
*** 157,165 ****
  
    cmd_prev_item_args[1].value = cmd_item_args[1].value =
      (XtArgVal) ((int) (gi_font_width * 65));
!   gi_cmd_prev_item = XtCreateManagedWidget("cmd_prev_item", asciiDiskWidgetClass,
! 					   cmd_panel,cmd_prev_item_args,
! 					   XtNumber(cmd_prev_item_args));
  
    prompt[0].value = (XtArgVal) gi_cmd_prev_item;
    cmd_item_args[2].value = (XtArgVal) gi_cmd_prev_item;
--- 181,195 ----
  
    cmd_prev_item_args[1].value = cmd_item_args[1].value =
      (XtArgVal) ((int) (gi_font_width * 65));
! #ifndef XtSpecificationRelease
!   gi_cmd_prev_item = XtCreateManagedWidget("cmd_prev_item",
! 			asciiDiskWidgetClass, cmd_panel,
! 			cmd_prev_item_args, XtNumber(cmd_prev_item_args));
! #else
!   gi_cmd_prev_item = XtCreateManagedWidget("cmd_prev_item",
! 			asciiTextWidgetClass, cmd_panel,
! 			cmd_prev_item_args, XtNumber(cmd_prev_item_args));
! #endif /* XtSpecificationRelease */
  
    prompt[0].value = (XtArgVal) gi_cmd_prev_item;
    cmd_item_args[2].value = (XtArgVal) gi_cmd_prev_item;
***************
*** 168,175 ****
  							    XtNumber(prompt));
  
    strcpy(cmd_item_buf, "");
!   cmd_item=XtCreateManagedWidget("cmd_item",asciiStringWidgetClass,cmd_panel,
! 				cmd_item_args, XtNumber(cmd_item_args));
    XtAddActions(actionsList, XtNumber(actionsList));
    translations = XtParseTranslationTable(override_trans_table);
    XtOverrideTranslations(cmd_item, translations);
--- 198,210 ----
  							    XtNumber(prompt));
  
    strcpy(cmd_item_buf, "");
! #ifndef XtSpecificationRelease
!   cmd_item=XtCreateManagedWidget("cmd_item", asciiStringWidgetClass, cmd_panel,
! 			cmd_item_args, XtNumber(cmd_item_args));
! #else
!   cmd_item=XtCreateManagedWidget("cmd_item", asciiTextWidgetClass, cmd_panel,
! 			cmd_item_args, XtNumber(cmd_item_args));
! #endif
    XtAddActions(actionsList, XtNumber(actionsList));
    translations = XtParseTranslationTable(override_trans_table);
    XtOverrideTranslations(cmd_item, translations);
***************
*** 188,198 ****
   */
    char cmd[MAX_CMD_LENGTH+1];
    int cmdlen, clock;
!   XtTextBlock text;
  
       /* save the command in a 'safe' area */
!   cmdlen = XtTextGetInsertionPoint(item) - XtTextTopPosition(item);
!   strncpy(cmd, cmd_item_buf+XtTextTopPosition(item), cmdlen);
    cmd[cmdlen] = '\0';
  
    /* execute the command */
--- 223,242 ----
   */
    char cmd[MAX_CMD_LENGTH+1];
    int cmdlen, clock;
! #ifndef XtSpecificationRelease
!   XtTextBlock text; 
! #else
!   XawTextBlock text;
! #endif /* XtSpecificationRelease */
  
       /* save the command in a 'safe' area */
! #ifndef XtSpecificationRelease
!   cmdlen =  XtTextGetInsertionPoint(item) - XtTextTopPosition(item);
!   strncpy(cmd, cmd_item_buf+XtTextTopPosition(item), cmdlen); 
! #else
!   cmdlen =  XawTextGetInsertionPoint(item) - XawTextTopPosition(item);
!   strncpy(cmd, cmd_item_buf+XawTextTopPosition(item), cmdlen); 
! #endif /* XtSpecificationRelease */
    cmd[cmdlen] = '\0';
  
    /* execute the command */
***************
*** 210,217 ****
    text.ptr = "";
    text.format = FMT8BIT;
    
!   XtTextReplace(item, 0, XtTextGetInsertionPoint(item), &text);
!   XtTextSetInsertionPoint(item, 0);
  }
  
  
--- 254,266 ----
    text.ptr = "";
    text.format = FMT8BIT;
    
! #ifndef XtSpecificationRelease
!   XtTextReplace(item, 0, XtTextGetInsertionPoint(item), &text); 
!   XtTextSetInsertionPoint(item, 0); 
! #else
!   XawTextReplace(item, 0, XawTextGetInsertionPoint(item), &text);
!   XawTextSetInsertionPoint(item, 0);
! #endif /* XtSpecificationRelease */
  }
  
  
***************
*** 1315,1321 ****
       char * cmd;
  
  {
!   XtTextBlock text;
    int inpos;
    char nlcmd[MAX_CMD_LENGTH+1];
  
--- 1364,1374 ----
       char * cmd;
  
  {
! #ifndef XtSpecificationRelease
!   XtTextBlock text; 
! #else
!   XawTextBlock text;
! #endif /* XtSpecificationRelease */
    int inpos;
    char nlcmd[MAX_CMD_LENGTH+1];
  
***************
*** 1331,1337 ****
        text.ptr = cmd;
        text.format = FMT8BIT;
        
!       inpos =  XtTextGetInsertionPoint(gi_cmd_prev_item);
!       XtTextReplace(gi_cmd_prev_item, inpos, inpos, &text);
      }
  }
--- 1384,1395 ----
        text.ptr = cmd;
        text.format = FMT8BIT;
        
! #ifndef XtSpecificationRelease
!       inpos = XtTextGetInsertionPoint(gi_cmd_prev_item);
!       XtTextReplace(gi_cmd_prev_item, inpos, inpos, &text); 
! #else
!       inpos = XawTextGetInsertionPoint(gi_cmd_prev_item);
!       XawTextReplace(gi_cmd_prev_item, inpos, inpos, &text);
! #endif /* XtSpecificationRelease */
      }
  }
diff -c -r rcs_dist/src/xgi/control_panel.c rcs_v4.2/src/xgi/control_panel.c
*** rcs_dist/src/xgi/control_panel.c	Tue Sep 26 14:01:10 1989
--- rcs_v4.2/src/xgi/control_panel.c	Tue Jun 12 13:37:50 1990
***************
*** 34,47 ****
  #include "externs.h"
  #include "panel.h"
  #include "cmd_panel.h"
! #include <X11/Viewport.h>
! #include <X11/Form.h>
! #include <X11/Text.h>
! #include <X11/AsciiText.h>
! #include <X11/Box.h>
! #include <X11/Xmu.h>
! #include <X11/Shell.h>
! #include <X11/Command.h>
  
  #define PAR_LEN 10
  
--- 34,58 ----
  #include "externs.h"
  #include "panel.h"
  #include "cmd_panel.h"
! #ifndef XtSpecificationRelease
! # include <X11/Viewport.h>
! # include <X11/Form.h>
! # include <X11/Text.h>
! # include <X11/AsciiText.h>
! # include <X11/Box.h>
! # include <X11/Xmu.h>
! # include <X11/Shell.h>
! # include <X11/Command.h>
! #else
! # include <X11/Xaw/Viewport.h>
! # include <X11/Xaw/Form.h>
! # include <X11/Xaw/Text.h>
! # include <X11/Xaw/AsciiText.h>
! # include <X11/Xaw/Box.h>
! # include <X11/Xmu/Xmu.h>
! # include <X11/Shell.h>
! # include <X11/Xaw/Command.h>
! #endif /* XtSpecificationRelease */
  
  #define PAR_LEN 10
  
***************
*** 95,102 ****
    { XtNborderWidth, (XtArgVal) 0},
    { XtNstring, (XtArgVal) custom_info},
    { XtNwidth, (XtArgVal) 400},
!   { XtNeditType, (XtArgVal)XttextRead},
!   { XtNtextOptions, (XtArgVal) wordBreak},
    { XtNheight, (XtArgVal) 400},
    { XtNfont, (XtArgVal) &gi_default_font }
  };
--- 106,120 ----
    { XtNborderWidth, (XtArgVal) 0},
    { XtNstring, (XtArgVal) custom_info},
    { XtNwidth, (XtArgVal) 400},
! #ifndef XtSpecificationRelease
!   { XtNeditType,  (XtArgVal)XttextRead},
!   { XtNtextOptions,  (XtArgVal) wordBreak},
! #else
!   { XtNuseStringInPlace,  (XtArgVal) True },
!   { XtNtype,  (XtArgVal) XawAsciiString },
!   { XtNeditType,  (XtArgVal)XawtextRead },
!   { XtNwrap,  (XtArgVal) XawtextWrapWord },
! #endif /* XtSpecificationRelease */
    { XtNheight, (XtArgVal) 400},
    { XtNfont, (XtArgVal) &gi_default_font }
  };
***************
*** 270,379 ****
         * spacex, * spacey, * wherex, * wherey;
  				/* change all the ranges */
  {
!   XtTextBlock text;
    int inpos;
  
    text.firstPos = 0;
    text.format = FMT8BIT;
  
!   if (lrange != NULL & strlen(lrange) <= MAX_CMD_LENGTH)
      if (gi_mode == MODE_MAIN)
        {
  	text.length = strlen(lrange);
  	text.ptr = lrange;
  	inpos =  strlen(gi_lrange_buf);
! 	XtTextReplace(gi_mitem[LRANGE_ITEM], 0, inpos, &text);
        }
      else
        (void) sprintf(gi_lrange_buf, lrange);
  
!   if (hrange != NULL & strlen(hrange) <= MAX_CMD_LENGTH)
      if (gi_mode == MODE_MAIN)
        {
  	text.length = strlen(hrange);
  	text.ptr = hrange;
  	inpos =  strlen(gi_hrange_buf);
! 	XtTextReplace(gi_mitem[HRANGE_ITEM], 0, inpos, &text);
        }
      else
        (void) sprintf(gi_hrange_buf, hrange);
!   if (llrange != NULL & strlen(llrange) <= MAX_CMD_LENGTH)
      if (gi_mode == MODE_LINK)
        {
  	text.length = strlen(llrange);
  	text.ptr = llrange;
  	inpos =  strlen(gi_llrange_buf);
! 	XtTextReplace(gi_litem[LLRANGE_ITEM], 0, inpos, &text);
        }
      else
        (void) sprintf(gi_llrange_buf, llrange);
!   if (lhrange != NULL & strlen(lhrange) <= MAX_CMD_LENGTH)
      if (gi_mode == MODE_LINK)
        {
  	text.length = strlen(lhrange);
  	text.ptr = lhrange;
  	inpos =  strlen(gi_lhrange_buf);
! 	XtTextReplace(gi_litem[LHRANGE_ITEM], 0, inpos, &text);
        }
      else
        (void) sprintf(gi_lhrange_buf, lhrange);
!   if (who != NULL & strlen(who) <= MAX_CMD_LENGTH)
      if (gi_mode == MODE_MAIN)
        {
  	text.length = strlen(who);
  	text.ptr = who;
  	inpos =  strlen(gi_who_buf);
! 	XtTextReplace(gi_mitem[WHO_ITEM], 0, inpos, &text);
        }
      else
        (void) sprintf(gi_who_buf, who);
!   if (ghowmany != NULL & strlen(ghowmany) <= MAX_CMD_LENGTH)
      if (gi_mode == MODE_MAIN)
        {
  	text.length = strlen(ghowmany);
  	text.ptr = ghowmany;
  	inpos =  strlen(gi_howmany_buf);
! 	XtTextReplace(gi_mitem[HOWMANY_ITEM], 0, inpos, &text);
        }
      else
        (void) sprintf(gi_howmany_buf, ghowmany);
!   if (spacex != NULL & strlen(spacex) <= MAX_CMD_LENGTH)
      if (gi_mode == MODE_MAIN)
        {
  	text.length = strlen(spacex);
  	text.ptr = spacex;
  	inpos =  strlen(gi_spacex_buf);
! 	XtTextReplace(gi_mitem[SPACEX_ITEM], 0, inpos, &text);
        }
      else
        (void) sprintf(gi_spacex_buf, spacex);
!   if (spacey != NULL & strlen(spacey) <= MAX_CMD_LENGTH)
      if (gi_mode == MODE_MAIN)
        {
  	text.length = strlen(spacey);
  	text.ptr = spacey;
  	inpos =  strlen(gi_spacey_buf);
! 	XtTextReplace(gi_mitem[SPACEY_ITEM], 0, inpos, &text);
        }
      else
        (void) sprintf(gi_spacey_buf, spacey);
!   if (wherex != NULL & strlen(wherex) <= MAX_CMD_LENGTH)
      if (gi_mode == MODE_MAIN)
        {
  	text.length = strlen(wherex);
  	text.ptr = wherex;
  	inpos =  strlen(gi_wherex_buf);
! 	XtTextReplace(gi_mitem[WHEREX_ITEM], 0, inpos, &text);
        }
      else
        (void) sprintf(gi_wherex_buf, wherex);
!   if (wherey != NULL & strlen(wherey) <= MAX_CMD_LENGTH)
      if (gi_mode == MODE_MAIN)
        {
  	text.length = strlen(wherey);
  	text.ptr = wherey;
  	inpos =  strlen(gi_wherey_buf);
! 	XtTextReplace(gi_mitem[WHEREY_ITEM], 0, inpos, &text);
        }
      else
        (void) sprintf(gi_wherey_buf, wherey);
--- 288,461 ----
         * spacex, * spacey, * wherex, * wherey;
  				/* change all the ranges */
  {
! #ifndef XtSpecificationRelease
!   XtTextBlock text; 
! #else
!   XawTextBlock text;
! #endif /* XtSpecificationRelease */
    int inpos;
  
    text.firstPos = 0;
    text.format = FMT8BIT;
  
!   if (lrange != NULL && strlen(lrange) <= MAX_CMD_LENGTH)
      if (gi_mode == MODE_MAIN)
        {
  	text.length = strlen(lrange);
  	text.ptr = lrange;
  	inpos =  strlen(gi_lrange_buf);
! #ifndef XtSpecificationRelease
! 	XtTextReplace(gi_mitem[LRANGE_ITEM], 0, inpos, &text); 
! 	XtTextSetInsertionPoint(gi_mitem[LRANGE_ITEM], text.length);
! #else
! 	XawTextReplace(gi_mitem[LRANGE_ITEM], 0, inpos, &text);
! 	XawTextSetInsertionPoint(gi_mitem[LRANGE_ITEM], text.length);
! #endif /* XtSpecificationRelease */
        }
      else
        (void) sprintf(gi_lrange_buf, lrange);
  
!   if (hrange != NULL && strlen(hrange) <= MAX_CMD_LENGTH)
      if (gi_mode == MODE_MAIN)
        {
  	text.length = strlen(hrange);
  	text.ptr = hrange;
  	inpos =  strlen(gi_hrange_buf);
! #ifndef XtSpecificationRelease
! 	XtTextReplace(gi_mitem[HRANGE_ITEM], 0, inpos, &text); 
! 	XtTextSetInsertionPoint(gi_mitem[HRANGE_ITEM], text.length);
! #else
! 	XawTextReplace(gi_mitem[HRANGE_ITEM], 0, inpos, &text);
! 	XawTextSetInsertionPoint(gi_mitem[HRANGE_ITEM], text.length);
! #endif /* XtSpecificationRelease */
        }
      else
        (void) sprintf(gi_hrange_buf, hrange);
!   if (llrange != NULL && strlen(llrange) <= MAX_CMD_LENGTH)
      if (gi_mode == MODE_LINK)
        {
  	text.length = strlen(llrange);
  	text.ptr = llrange;
  	inpos =  strlen(gi_llrange_buf);
! #ifndef XtSpecificationRelease
! 	XtTextReplace(gi_litem[LLRANGE_ITEM], 0, inpos, &text); 
! 	XtTextSetInsertionPoint(gi_mitem[LLRANGE_ITEM], text.length);
! #else
! 	XawTextReplace(gi_litem[LLRANGE_ITEM], 0, inpos, &text);
! 	XawTextSetInsertionPoint(gi_mitem[LLRANGE_ITEM], text.length);
! #endif /* XtSpecificationRelease */
        }
      else
        (void) sprintf(gi_llrange_buf, llrange);
!   if (lhrange != NULL && strlen(lhrange) <= MAX_CMD_LENGTH)
      if (gi_mode == MODE_LINK)
        {
  	text.length = strlen(lhrange);
  	text.ptr = lhrange;
  	inpos =  strlen(gi_lhrange_buf);
! #ifndef XtSpecificationRelease
! 	XtTextReplace(gi_litem[LHRANGE_ITEM], 0, inpos, &text); 
! 	XtTextSetInsertionPoint(gi_mitem[LHRANGE_ITEM], text.length);
! #else
! 	XawTextReplace(gi_litem[LHRANGE_ITEM], 0, inpos, &text);
! 	XawTextSetInsertionPoint(gi_mitem[LHRANGE_ITEM], text.length);
! #endif /* XtSpecificationRelease */
        }
      else
        (void) sprintf(gi_lhrange_buf, lhrange);
!   if (who != NULL && strlen(who) <= MAX_CMD_LENGTH)
      if (gi_mode == MODE_MAIN)
        {
  	text.length = strlen(who);
  	text.ptr = who;
  	inpos =  strlen(gi_who_buf);
! #ifndef XtSpecificationRelease
! 	XtTextReplace(gi_mitem[WHO_ITEM], 0, inpos, &text); 
! 	XtTextSetInsertionPoint(gi_mitem[WHO_ITEM], text.length);
! #else
! 	XawTextReplace(gi_mitem[WHO_ITEM], 0, inpos, &text);
! 	XawTextSetInsertionPoint(gi_mitem[WHO_ITEM], text.length);
! #endif /* XtSpecificationRelease */
        }
      else
        (void) sprintf(gi_who_buf, who);
!   if (ghowmany != NULL && strlen(ghowmany) <= MAX_CMD_LENGTH)
      if (gi_mode == MODE_MAIN)
        {
  	text.length = strlen(ghowmany);
  	text.ptr = ghowmany;
  	inpos =  strlen(gi_howmany_buf);
! #ifndef XtSpecificationRelease
! 	XtTextReplace(gi_mitem[HOWMANY_ITEM], 0, inpos, &text); 
! 	XtTextSetInsertionPoint(gi_mitem[HOWMANY_ITEM], text.length);
! #else
! 	XawTextReplace(gi_mitem[HOWMANY_ITEM], 0, inpos, &text);
! 	XawTextSetInsertionPoint(gi_mitem[HOWMANY_ITEM], text.length);
! #endif /* XtSpecificationRelease */
        }
      else
        (void) sprintf(gi_howmany_buf, ghowmany);
!   if (spacex != NULL && strlen(spacex) <= MAX_CMD_LENGTH)
      if (gi_mode == MODE_MAIN)
        {
  	text.length = strlen(spacex);
  	text.ptr = spacex;
  	inpos =  strlen(gi_spacex_buf);
! #ifndef XtSpecificationRelease
! 	XtTextReplace(gi_mitem[SPACEX_ITEM], 0, inpos, &text); 
! 	XtTextSetInsertionPoint(gi_mitem[SPACEX_ITEM], text.length);
! #else
! 	XawTextReplace(gi_mitem[SPACEX_ITEM], 0, inpos, &text);
! 	XawTextSetInsertionPoint(gi_mitem[SPACEX_ITEM], text.length);
! #endif /* XtSpecificationRelease */
        }
      else
        (void) sprintf(gi_spacex_buf, spacex);
!   if (spacey != NULL && strlen(spacey) <= MAX_CMD_LENGTH)
      if (gi_mode == MODE_MAIN)
        {
  	text.length = strlen(spacey);
  	text.ptr = spacey;
  	inpos =  strlen(gi_spacey_buf);
! #ifndef XtSpecificationRelease
! 	XtTextReplace(gi_mitem[SPACEY_ITEM], 0, inpos, &text); 
! 	XtTextSetInsertionPoint(gi_mitem[SPACEY_ITEM], text.length);
! #else
! 	XawTextReplace(gi_mitem[SPACEY_ITEM], 0, inpos, &text);
! 	XawTextSetInsertionPoint(gi_mitem[SPACEY_ITEM], text.length);
! #endif /* XtSpecificationRelease */
        }
      else
        (void) sprintf(gi_spacey_buf, spacey);
!   if (wherex != NULL && strlen(wherex) <= MAX_CMD_LENGTH)
      if (gi_mode == MODE_MAIN)
        {
  	text.length = strlen(wherex);
  	text.ptr = wherex;
  	inpos =  strlen(gi_wherex_buf);
! #ifndef XtSpecificationRelease
! 	XtTextReplace(gi_mitem[WHEREX_ITEM], 0, inpos, &text); 
! 	XtTextSetInsertionPoint(gi_mitem[WHEREX_ITEM], text.length);
! #else
! 	XawTextReplace(gi_mitem[WHEREX_ITEM], 0, inpos, &text);
! 	XawTextSetInsertionPoint(gi_mitem[WHEREX_ITEM], text.length);
! #endif /* XtSpecificationRelease */
        }
      else
        (void) sprintf(gi_wherex_buf, wherex);
!   if (wherey != NULL && strlen(wherey) <= MAX_CMD_LENGTH)
      if (gi_mode == MODE_MAIN)
        {
  	text.length = strlen(wherey);
  	text.ptr = wherey;
  	inpos =  strlen(gi_wherey_buf);
! #ifndef XtSpecificationRelease
! 	XtTextReplace(gi_mitem[WHEREY_ITEM], 0, inpos, &text); 
! 	XtTextSetInsertionPoint(gi_mitem[WHEREY_ITEM], text.length);
! #else
! 	XawTextReplace(gi_mitem[WHEREY_ITEM], 0, inpos, &text);
! 	XawTextSetInsertionPoint(gi_mitem[WHEREY_ITEM], text.length);
! #endif /* XtSpecificationRelease */
        }
      else
        (void) sprintf(gi_wherey_buf, wherey);
***************
*** 410,415 ****
--- 492,498 ----
    {
      { XtNx, (XtArgVal) 500 },
      { XtNy, (XtArgVal) 300 },
+     { XtNinput, (XtArgVal) True },
    };
  
  Widget layout_box;
***************
*** 431,449 ****
  
       /* items only displayed during MAIN mode */
  /* NHG this is a mess, should all be done elsewhere */
!   gi_layout_panel = XtCreatePopupShell("LAYOUT",transientShellWidgetClass,
  				     gi_tool, layout_loc, XtNumber(layout_loc));
  
    gi_main_shell = XtCreateManagedWidget("MAIN_SHELL", boxWidgetClass,
! 					gi_layout_panel, no_bdr, 1);
    temp = XtCreateManagedWidget("WHO_HOW_BOX", formWidgetClass, gi_main_shell,
! 			       no_bdr, 1);
    temp3 = XtCreateManagedWidget("WHO_ITEM", formWidgetClass,temp,
! 					     no_bdr, 1);
    temp2 = AddText(temp3,"WHO: ",XtJustifyRight, NULL);
    strcpy(gi_who_buf,"0");
!   gi_mitem[WHO_ITEM] = AddTextEdit(temp3,"WHO_TEXT",gi_who_buf, temp2,
! 	      MAX_CMD_LENGTH, 40);
    vertical_args[0].value = (XtArgVal) temp3;
    temp3 = XtCreateManagedWidget("HOWMANY_ITEM",formWidgetClass,temp,
  						 vertical_args, XtNumber(vertical_args));
--- 514,531 ----
  
       /* items only displayed during MAIN mode */
  /* NHG this is a mess, should all be done elsewhere */
!   gi_layout_panel = XtCreatePopupShell("LAYOUT",topLevelShellWidgetClass,
  				     gi_tool, layout_loc, XtNumber(layout_loc));
  
    gi_main_shell = XtCreateManagedWidget("MAIN_SHELL", boxWidgetClass,
! 					gi_layout_panel, no_bdr, XtNumber(no_bdr));
    temp = XtCreateManagedWidget("WHO_HOW_BOX", formWidgetClass, gi_main_shell,
! 			       no_bdr, XtNumber(no_bdr));
    temp3 = XtCreateManagedWidget("WHO_ITEM", formWidgetClass,temp,
! 					     no_bdr, XtNumber(no_bdr));
    temp2 = AddText(temp3,"WHO: ",XtJustifyRight, NULL);
    strcpy(gi_who_buf,"0");
!   gi_mitem[WHO_ITEM] = AddTextEdit(temp3,"WHO_TEXT",gi_who_buf, temp2, MAX_CMD_LENGTH, 40);
    vertical_args[0].value = (XtArgVal) temp3;
    temp3 = XtCreateManagedWidget("HOWMANY_ITEM",formWidgetClass,temp,
  						 vertical_args, XtNumber(vertical_args));
***************
*** 460,466 ****
       */
  
    gi_mitem[WHAT_ITEM] = XtCreateManagedWidget("WHAT_ITEM", formWidgetClass,
! 					      gi_main_shell, no_bdr, 1);
    layout_args[0].value = (XtArgVal) AddText(gi_mitem[WHAT_ITEM], "WHAT", XtJustifyRight, NULL);
    temp = XtCreateManagedWidget("WHAT_RADIO_BOX", formWidgetClass, gi_mitem[WHAT_ITEM],
  				layout_args, XtNumber(layout_args));
--- 542,548 ----
       */
  
    gi_mitem[WHAT_ITEM] = XtCreateManagedWidget("WHAT_ITEM", formWidgetClass,
! 					      gi_main_shell, no_bdr, XtNumber(no_bdr));
    layout_args[0].value = (XtArgVal) AddText(gi_mitem[WHAT_ITEM], "WHAT", XtJustifyRight, NULL);
    temp = XtCreateManagedWidget("WHAT_RADIO_BOX", formWidgetClass, gi_mitem[WHAT_ITEM],
  				layout_args, XtNumber(layout_args));
***************
*** 484,490 ****
    XtUnmanageChild(gi_mitem[TARGET_ITEM]);
  
    gi_mitem[HOW_ITEM] =  XtCreateManagedWidget("HOW_ITEM",formWidgetClass,gi_main_shell,
! 					      no_bdr, 1);
    layout_args[0].value = (XtArgVal) AddText(gi_mitem[HOW_ITEM], "HOW", XtJustifyRight, NULL);
    temp = XtCreateManagedWidget("HOW_RADIO_BOX", formWidgetClass, gi_mitem[HOW_ITEM],
  				layout_args, XtNumber(layout_args));
--- 566,572 ----
    XtUnmanageChild(gi_mitem[TARGET_ITEM]);
  
    gi_mitem[HOW_ITEM] =  XtCreateManagedWidget("HOW_ITEM",formWidgetClass,gi_main_shell,
! 					      no_bdr, XtNumber(no_bdr));
    layout_args[0].value = (XtArgVal) AddText(gi_mitem[HOW_ITEM], "HOW", XtJustifyRight, NULL);
    temp = XtCreateManagedWidget("HOW_RADIO_BOX", formWidgetClass, gi_mitem[HOW_ITEM],
  				layout_args, XtNumber(layout_args));
***************
*** 496,507 ****
  #endif
  
    gi_mitem[WHERE_ITEM]=XtCreateManagedWidget("WHERE_ITEM",formWidgetClass,gi_main_shell,
! 					     no_bdr, 1);
    layout_args[0].value = (XtArgVal) AddText(gi_mitem[WHERE_ITEM],"WHERE",
  					    XtJustifyRight, NULL);
    params = XtCreateManagedWidget("WHERE_PARAMS", boxWidgetClass, gi_mitem[WHERE_ITEM],
  			       layout_args, XtNumber(layout_args));
!   loc = XtCreateManagedWidget("WHERE", formWidgetClass, params, no_bdr, 1);
    temp = AddText(loc, "start x:", XtJustifyRight, NULL);
    strcpy(gi_wherex_buf,"5");
    gi_mitem[WHEREX_ITEM] = temp = AddTextEdit(loc,"WHEREX_TEXT", gi_wherex_buf,
--- 578,589 ----
  #endif
  
    gi_mitem[WHERE_ITEM]=XtCreateManagedWidget("WHERE_ITEM",formWidgetClass,gi_main_shell,
! 					     no_bdr, XtNumber(no_bdr));
    layout_args[0].value = (XtArgVal) AddText(gi_mitem[WHERE_ITEM],"WHERE",
  					    XtJustifyRight, NULL);
    params = XtCreateManagedWidget("WHERE_PARAMS", boxWidgetClass, gi_mitem[WHERE_ITEM],
  			       layout_args, XtNumber(layout_args));
!   loc = XtCreateManagedWidget("WHERE", formWidgetClass, params, no_bdr, XtNumber(no_bdr));
    temp = AddText(loc, "start x:", XtJustifyRight, NULL);
    strcpy(gi_wherex_buf,"5");
    gi_mitem[WHEREX_ITEM] = temp = AddTextEdit(loc,"WHEREX_TEXT", gi_wherex_buf,
***************
*** 511,517 ****
    gi_mitem[WHEREY_ITEM] = AddTextEdit(loc,"WHEREY_TEXT",gi_wherey_buf, temp,
  				      PAR_LEN, PAR_LEN );
  
!   spc = XtCreateManagedWidget("SPACING", formWidgetClass, params, no_bdr, 1);
    temp = AddText(spc,"space x:",XtJustifyRight, NULL);
    strcpy(gi_spacex_buf,"5");
    gi_mitem[SPACEX_ITEM] = temp = AddTextEdit(spc,"SPACEX_TEXT", gi_spacex_buf, temp,
--- 593,599 ----
    gi_mitem[WHEREY_ITEM] = AddTextEdit(loc,"WHEREY_TEXT",gi_wherey_buf, temp,
  				      PAR_LEN, PAR_LEN );
  
!   spc = XtCreateManagedWidget("SPACING", formWidgetClass, params, no_bdr, XtNumber(no_bdr));
    temp = AddText(spc,"space x:",XtJustifyRight, NULL);
    strcpy(gi_spacex_buf,"5");
    gi_mitem[SPACEX_ITEM] = temp = AddTextEdit(spc,"SPACEX_TEXT", gi_spacex_buf, temp,
***************
*** 522,528 ****
  				      PAR_LEN, PAR_LEN);
  
    cols = XtCreateManagedWidget("NUMCOLS_ITEM", formWidgetClass, params,
! 			       no_bdr, 1);
    temp = AddText(cols,"units per row:",XtJustifyRight, NULL);
    strcpy(gi_numcols_buf,"max");
    temp = AddTextEdit(cols,"NUMCOLS_TEXT",gi_numcols_buf, temp,
--- 604,610 ----
  				      PAR_LEN, PAR_LEN);
  
    cols = XtCreateManagedWidget("NUMCOLS_ITEM", formWidgetClass, params,
! 			       no_bdr, XtNumber(no_bdr));
    temp = AddText(cols,"units per row:",XtJustifyRight, NULL);
    strcpy(gi_numcols_buf,"max");
    temp = AddTextEdit(cols,"NUMCOLS_TEXT",gi_numcols_buf, temp,
***************
*** 529,535 ****
  		     PAR_LEN, PAR_LEN);
  
    temp=XtCreateManagedWidget("SCE_BOX", formWidgetClass, gi_main_shell,
! 			     no_bdr, 1);
    gi_mitem[SHOW_ITEM] = AddButton(temp, "SHOW", show_proc, 0, NULL);
    gi_mitem[CHANGE_ITEM] = AddButton(temp, "CHANGE", change_proc, 0,gi_mitem[SHOW_ITEM]);
    gi_mitem[ERASE_ITEM] = AddButton(temp, "ERASE", erase_proc, 0, gi_mitem[CHANGE_ITEM]);
--- 611,617 ----
  		     PAR_LEN, PAR_LEN);
  
    temp=XtCreateManagedWidget("SCE_BOX", formWidgetClass, gi_main_shell,
! 			     no_bdr, XtNumber(no_bdr));
    gi_mitem[SHOW_ITEM] = AddButton(temp, "SHOW", show_proc, 0, NULL);
    gi_mitem[CHANGE_ITEM] = AddButton(temp, "CHANGE", change_proc, 0,gi_mitem[SHOW_ITEM]);
    gi_mitem[ERASE_ITEM] = AddButton(temp, "ERASE", erase_proc, 0, gi_mitem[CHANGE_ITEM]);
***************
*** 538,546 ****
       /* items displayed only during LINK mode */
  
    gi_link_shell = XtCreateManagedWidget("LINK_SHELL", boxWidgetClass,
! 				 gi_layout_panel, no_bdr, 1);
    temp = XtCreateManagedWidget("LTARGET_BOX",formWidgetClass,gi_link_shell,
! 			       no_bdr, 1);
    temp2 = AddText(temp,"TARGET",XtJustifyRight, NULL);
    strcpy(gi_ltarget_buf, ANY_SITE);
    gi_litem[LSITE_ITEM] = AddTextEdit(temp,"LSITE_TEXT",gi_ltarget_buf, temp2,
--- 620,628 ----
       /* items displayed only during LINK mode */
  
    gi_link_shell = XtCreateManagedWidget("LINK_SHELL", boxWidgetClass,
! 				 gi_layout_panel, no_bdr, XtNumber(no_bdr));
    temp = XtCreateManagedWidget("LTARGET_BOX",formWidgetClass,gi_link_shell,
! 			       no_bdr, XtNumber(no_bdr));
    temp2 = AddText(temp,"TARGET",XtJustifyRight, NULL);
    strcpy(gi_ltarget_buf, ANY_SITE);
    gi_litem[LSITE_ITEM] = AddTextEdit(temp,"LSITE_TEXT",gi_ltarget_buf, temp2,
***************
*** 547,553 ****
  				     MAX_CMD_LENGTH, 30);
  
    gi_litem[LHOW_ITEM] =  XtCreateManagedWidget("LHOW_ITEM",formWidgetClass,
! 					      gi_link_shell, no_bdr, 1);
    layout_args[0].value = (XtArgVal) AddText(gi_litem[LHOW_ITEM], "HOW", XtJustifyRight, NULL);
    temp = XtCreateManagedWidget("LHOW_RADIO_BOX", formWidgetClass, gi_litem[LHOW_ITEM],
  				layout_args, XtNumber(layout_args)); 
--- 629,635 ----
  				     MAX_CMD_LENGTH, 30);
  
    gi_litem[LHOW_ITEM] =  XtCreateManagedWidget("LHOW_ITEM",formWidgetClass,
! 					      gi_link_shell, no_bdr, XtNumber(no_bdr));
    layout_args[0].value = (XtArgVal) AddText(gi_litem[LHOW_ITEM], "HOW", XtJustifyRight, NULL);
    temp = XtCreateManagedWidget("LHOW_RADIO_BOX", formWidgetClass, gi_litem[LHOW_ITEM],
  				layout_args, XtNumber(layout_args)); 
***************
*** 567,573 ****
  				       temp2, PAR_LEN, PAR_LEN);
  
    temp = XtCreateManagedWidget("LDIR_BOX",formWidgetClass,
! 			       gi_link_shell, no_bdr, 1);
    layout_args[0].value = (XtArgVal) AddText(temp, "DIRECTION",
  					    XtJustifyRight, NULL);
    temp2 = XtCreateManagedWidget("LHOW_RADIO_BOX", formWidgetClass, temp,
--- 649,655 ----
  				       temp2, PAR_LEN, PAR_LEN);
  
    temp = XtCreateManagedWidget("LDIR_BOX",formWidgetClass,
! 			       gi_link_shell, no_bdr, XtNumber(no_bdr));
    layout_args[0].value = (XtArgVal) AddText(temp, "DIRECTION",
  					    XtJustifyRight, NULL);
    temp2 = XtCreateManagedWidget("LHOW_RADIO_BOX", formWidgetClass, temp,
***************
*** 578,586 ****
  
    /* items displayed only during TEXT mode */
    gi_text_shell = XtCreateManagedWidget("TEXT_SHELL", boxWidgetClass,
! 				 gi_layout_panel, no_bdr, 1);
    temp = XtCreateManagedWidget("FONT_RADIO_BOX", formWidgetClass, gi_text_shell,
! 				no_bdr, 1);
    AddRadio(temp,"FONT_RADIO",font_proc, font_labels,4,0,&gi_font_buttons);
    AddButton(gi_text_shell, "CLOSE", close_layout_proc, gi_layout_panel, NULL);
    XtUnmanageChild(gi_text_shell);
--- 660,668 ----
  
    /* items displayed only during TEXT mode */
    gi_text_shell = XtCreateManagedWidget("TEXT_SHELL", boxWidgetClass,
! 				 gi_layout_panel, no_bdr, XtNumber(no_bdr));
    temp = XtCreateManagedWidget("FONT_RADIO_BOX", formWidgetClass, gi_text_shell,
! 				no_bdr, XtNumber(no_bdr));
    AddRadio(temp,"FONT_RADIO",font_proc, font_labels,4,0,&gi_font_buttons);
    AddButton(gi_text_shell, "CLOSE", close_layout_proc, gi_layout_panel, NULL);
    XtUnmanageChild(gi_text_shell);
***************
*** 587,593 ****
  
    /* items displayed only during DRAW mode */
    gi_draw_shell = XtCreateManagedWidget("DRAW_SHELL", formWidgetClass, 
! 					gi_layout_panel, no_bdr, 1);
    layout_args[0].value = (XtArgVal) AddText(gi_draw_shell,"TYPE",XtJustifyRight, NULL);
    temp = XtCreateManagedWidget("DTYPE_RADIO_BOX", formWidgetClass, gi_draw_shell,
  			       layout_args, XtNumber(layout_args));
--- 669,675 ----
  
    /* items displayed only during DRAW mode */
    gi_draw_shell = XtCreateManagedWidget("DRAW_SHELL", formWidgetClass, 
! 					gi_layout_panel, no_bdr, XtNumber(no_bdr));
    layout_args[0].value = (XtArgVal) AddText(gi_draw_shell,"TYPE",XtJustifyRight, NULL);
    temp = XtCreateManagedWidget("DTYPE_RADIO_BOX", formWidgetClass, gi_draw_shell,
  			       layout_args, XtNumber(layout_args));
***************
*** 598,604 ****
  
      /* items only displayed during CUSTOM mode */
    gi_custom_shell = XtCreateManagedWidget("CUST_SHELL", formWidgetClass,
! 					  gi_layout_panel, no_bdr, 1);
  
    temp = gi_citem[CLOG_ITEM] = AddButton(gi_custom_shell,"LOG CUSTOM MENUS",
  					 custlog_proc, 0, NULL);
--- 680,686 ----
  
      /* items only displayed during CUSTOM mode */
    gi_custom_shell = XtCreateManagedWidget("CUST_SHELL", formWidgetClass,
! 					  gi_layout_panel, no_bdr, XtNumber(no_bdr));
  
    temp = gi_citem[CLOG_ITEM] = AddButton(gi_custom_shell,"LOG CUSTOM MENUS",
  					 custlog_proc, 0, NULL);
***************
*** 606,618 ****
  
  
    custom_args[0].value = (XtArgVal) temp;
!   XtCreateManagedWidget("CUSTOM_BOX", asciiStringWidgetClass, gi_custom_shell,
! 			       custom_args, XtNumber(custom_args));
    XtUnmanageChild(gi_custom_shell);
  
      /* items displayed during all modes */
      temp = XtCreateManagedWidget("STATUS_BOX",formWidgetClass,gi_control_panel,
! 				 no_bdr, 1);
  
      temp2 = AddText(temp,"Clock=",XtJustifyRight, NULL);
      strcpy(gi_clock_buf,"0          ");
--- 688,703 ----
  
  
    custom_args[0].value = (XtArgVal) temp;
! #ifndef XtSpecificationRelease
!   XtCreateManagedWidget("CUSTOM_BOX", asciiStringWidgetClass, gi_custom_shell, custom_args, XtNumber(custom_args));
! #else
!   XtCreateManagedWidget("CUSTOM_BOX", asciiTextWidgetClass, gi_custom_shell, custom_args, XtNumber(custom_args));
! #endif /* XtSpecificationRelease */
    XtUnmanageChild(gi_custom_shell);
  
      /* items displayed during all modes */
      temp = XtCreateManagedWidget("STATUS_BOX",formWidgetClass,gi_control_panel,
! 				 no_bdr, XtNumber(no_bdr));
  
      temp2 = AddText(temp,"Clock=",XtJustifyRight, NULL);
      strcpy(gi_clock_buf,"0          ");
***************
*** 629,635 ****
  				  PAR_LEN, PAR_LEN);
  
      temp = XtCreateManagedWidget("DRQ_BOX", formWidgetClass, gi_control_panel,
! 				 no_bdr, 1);
  #if 0
  				/* use xwd instead.  this code should disappear */
      temp2 = AddButton(temp,"DUMP",dump_proc,0, NULL);
--- 714,720 ----
  				  PAR_LEN, PAR_LEN);
  
      temp = XtCreateManagedWidget("DRQ_BOX", formWidgetClass, gi_control_panel,
! 				 no_bdr, XtNumber(no_bdr));
  #if 0
  				/* use xwd instead.  this code should disappear */
      temp2 = AddButton(temp,"DUMP",dump_proc,0, NULL);
***************
*** 719,724 ****
--- 804,810 ----
      {
        { XtNx, (XtArgVal) 300 },
        { XtNy, (XtArgVal) 300 },
+       { XtNinput, (XtArgVal) False },
      };
    static Arg q[] =
      {
***************
*** 727,735 ****
      };
    static Arg help_item_args[] = {
  		{ XtNwidth, (XtArgVal)600 },
! 		{ XtNfile, (XtArgVal) filenamebuf },
! 		{ XtNeditType, (XtArgVal)XttextRead},
! 		{ XtNtextOptions, (XtArgVal) (scrollVertical | wordBreak)},
  		{ XtNheight, (XtArgVal)400 },
  		{ XtNfont, (XtArgVal) &gi_default_font }
  	      };
--- 813,829 ----
      };
    static Arg help_item_args[] = {
  		{ XtNwidth, (XtArgVal)600 },
! #ifndef XtSpecificationRelease
! 		{ XtNfile,  (XtArgVal) filenamebuf },
! 		{ XtNeditType,  (XtArgVal)XttextRead},
! 		{ XtNtextOptions,  (XtArgVal) (scrollVertical | wordBreak)},
! #else
! 		{ XtNstring, (XtArgVal) filenamebuf },
! 		{ XtNtype, (XtArgVal) XawAsciiFile },
! 		{ XtNeditType, (XtArgVal) XawtextRead},
! 		{ XtNwrap, (XtArgVal) XawtextWrapWord },
! 		{ XtNscrollVertical, (XtArgVal) XawtextScrollAlways },
! #endif /* XtSpecificationRelease */
  		{ XtNheight, (XtArgVal)400 },
  		{ XtNfont, (XtArgVal) &gi_default_font }
  	      };
***************
*** 740,753 ****
      { XtNfont, (XtArgVal) &gi_default_font },
    };
  
!   namepopup = XtCreatePopupShell("RCS HELP",transientShellWidgetClass,
! 				     w, p, XtNumber(p));
    temp = XtCreateManagedWidget("help_box", formWidgetClass, namepopup, q, XtNumber(q));
    (void) sprintf(filenamebuf, "%s/xgi.help", XGIDIR);
    help_item_args[0].value = (XtArgVal) ((int) (100 * gi_font_width));
!   h[0].value = (XtArgVal) XtCreateManagedWidget("help_item", asciiDiskWidgetClass,
! 					   temp,help_item_args,
! 					   XtNumber(help_item_args));
    
    temp = XtCreateManagedWidget("CLOSE", commandWidgetClass, temp, h, XtNumber(h));
    XtAddCallback(temp,XtNcallback,close_help_item,namepopup);
--- 834,852 ----
      { XtNfont, (XtArgVal) &gi_default_font },
    };
  
!   namepopup = XtCreatePopupShell("RCS HELP",topLevelShellWidgetClass, w, p, XtNumber(p));
    temp = XtCreateManagedWidget("help_box", formWidgetClass, namepopup, q, XtNumber(q));
    (void) sprintf(filenamebuf, "%s/xgi.help", XGIDIR);
    help_item_args[0].value = (XtArgVal) ((int) (100 * gi_font_width));
! #ifndef XtSpecificationRelease
!   h[0].value = (XtArgVal) XtCreateManagedWidget("help_item",
! 				asciiDiskWidgetClass, temp,
! 				help_item_args, XtNumber(help_item_args));
! #else
!   h[0].value = (XtArgVal) XtCreateManagedWidget("help_item",
! 				asciiTextWidgetClass, temp,
! 				help_item_args, XtNumber(help_item_args));
! #endif /* XtSpecificationRelease */
    
    temp = XtCreateManagedWidget("CLOSE", commandWidgetClass, temp, h, XtNumber(h));
    XtAddCallback(temp,XtNcallback,close_help_item,namepopup);
***************
*** 900,919 ****
  
  #if 0
    /* set the default low and high range values */
!   XtTextBlock text;
    int inpos;
    text.firstPos = 0;
    text.format = FMT8BIT;
    text.length = strlen(lrange);
    text.ptr = lrange;
!   inpos =  XtTextGetInsertionPoint(gi_mitem[LRANGE_ITEM]);
!   XtTextReplace(gi_mitem[LRANGE_ITEM], 0, inpos, &text);
  
    strcpy(gi_hrange_buf,hrange);
    text.length = strlen(gi_hrange_buf);
    text.ptr = gi_hrange_buf;
!   inpos =  XtTextGetInsertionPoint(gi_mitem[HRANGE_ITEM]);
!   XtTextReplace(gi_mitem[HRANGE_ITEM], 0, inpos, &text);
  
    strcpy(gi_lrange_buf,lrange);
    SetValue(gi_mitem[LRANGE_ITEM],XtNstring,gi_lrange_buf);
--- 999,1030 ----
  
  #if 0
    /* set the default low and high range values */
! #ifndef XtSpecificationRelease
!   XtTextBlock text; 
! #else
!   XawTextBlock text;
! #endif /* XtSpecificationRelease */
    int inpos;
    text.firstPos = 0;
    text.format = FMT8BIT;
    text.length = strlen(lrange);
    text.ptr = lrange;
!   inpos = strlen(gi_lrange_buf);
! #ifndef XtSpecificationRelease
!   XtTextReplace(gi_mitem[LRANGE_ITEM], 0, inpos, &text); 
! #else
!   XawTextReplace(gi_mitem[LRANGE_ITEM], 0, inpos, &text);
! #endif /* XtSpecificationRelease */
  
    strcpy(gi_hrange_buf,hrange);
    text.length = strlen(gi_hrange_buf);
    text.ptr = gi_hrange_buf;
!   inpos = strlen(gi_hrange_buf);
! #ifndef XtSpecificationRelease
!   XtTextReplace(gi_mitem[HRANGE_ITEM], 0, inpos, &text); 
! #else
!   XawTextReplace(gi_mitem[HRANGE_ITEM], 0, inpos, &text);
! #endif /* XtSpecificationRelease */
  
    strcpy(gi_lrange_buf,lrange);
    SetValue(gi_mitem[LRANGE_ITEM],XtNstring,gi_lrange_buf);
***************
*** 1106,1112 ****
        char * newname;
        FILE * fp;
  
!       newname = XtDialogGetValueString(XtParent(w));
        if ((fp = fopen(newname,"w")) == NULL)
  	{
  	  gi_put_error("Can't create log file");
--- 1217,1227 ----
        char * newname;
        FILE * fp;
  
! #ifndef XtSpecificationRelease
!       newname =  XtDialogGetValueString(XtParent(w));
! #else
!       newname =  XawDialogGetValueString(XtParent(w));
! #endif /* XtSpecificationRelease */
        if ((fp = fopen(newname,"w")) == NULL)
  	{
  	  gi_put_error("Can't create log file");
***************
*** 1135,1141 ****
        switch_logfile_toggle(w, popup, call_data);
        return;
      }
!   newname = XtDialogGetValueString(XtParent(w));
    if (strcmp(newname, gi_logfile_name))
      {
        if ((fp = fopen(newname,"w")) == NULL)
--- 1250,1260 ----
        switch_logfile_toggle(w, popup, call_data);
        return;
      }
! #ifndef XtSpecificationRelease
!   newname =  XtDialogGetValueString(XtParent(w));
! #else
!   newname =  XawDialogGetValueString(XtParent(w));
! #endif /* XtSpecificationRelease */
    if (strcmp(newname, gi_logfile_name))
      {
        if ((fp = fopen(newname,"w")) == NULL)
***************
*** 1182,1187 ****
--- 1301,1307 ----
      {
        { XtNx, (XtArgVal) 0 },
        { XtNy, (XtArgVal) 0 },
+       { XtNinput, (XtArgVal) True },
      };
    static Arg q[] =
      {
diff -c -r rcs_dist/src/xgi/display_panel.c rcs_v4.2/src/xgi/display_panel.c
*** rcs_dist/src/xgi/display_panel.c	Thu Oct 12 14:40:30 1989
--- rcs_v4.2/src/xgi/display_panel.c	Tue Jun 12 13:40:21 1990
***************
*** 39,52 ****
  #include <X11/Xlib.h>
  #include <X11/Xutil.h>
  #include <X11/Shell.h>
! #include <X11/Label.h>
! #include <X11/Command.h>
! #include <X11/Box.h>
  #include <X11/IntrinsicP.h>
  #include <X11/StringDefs.h>
! #include <X11/VPanedP.h>
! #include <X11/Grip.h>
! #include <X11/VPaned.h>
  #include "Display.h"
  
  extern Widget gi_display_popup;
--- 39,63 ----
  #include <X11/Xlib.h>
  #include <X11/Xutil.h>
  #include <X11/Shell.h>
! #ifndef XtSpecificationRelease
! # include <X11/Label.h>
! # include <X11/Command.h>
! # include <X11/Box.h>
! #else
! # include <X11/Xaw/Label.h>
! # include <X11/Xaw/Command.h>
! # include <X11/Xaw/Box.h>
! #endif /* XtSpecificationRelease */
  #include <X11/IntrinsicP.h>
  #include <X11/StringDefs.h>
! #ifndef XtSpecificationRelease
! # include <X11/VPanedP.h>
! # include <X11/Grip.h>
! # include <X11/VPaned.h>
! #else
! # include <X11/Xaw/Grip.h>
! # include <X11/Xaw/Paned.h>
! #endif /* XtSpecificationRelease */
  #include "Display.h"
  
  extern Widget gi_display_popup;
***************
*** 196,202 ****
       caddr_t call_data;
  
  {
!   (void) sprintf(ipanel->name, "%s", XtDialogGetValueString(ipanel->namedialog));
    SetValue(ipanel->namewid, XtNlabel, ipanel->name);
    XSetIconName(XtDisplay(gi_tool), XtWindow(ipanel->popup), ipanel->name);
    XtDestroyWidget(ipanel->namepopup);
--- 207,217 ----
       caddr_t call_data;
  
  {
! #ifndef XtSpecificationRelease
!   (void) strcpy(ipanel->name, XtDialogGetValueString(ipanel->namedialog));
! #else
!   (void) strcpy(ipanel->name, XawDialogGetValueString(ipanel->namedialog));
! #endif /* XtSpecificationRelease */
    SetValue(ipanel->namewid, XtNlabel, ipanel->name);
    XSetIconName(XtDisplay(gi_tool), XtWindow(ipanel->popup), ipanel->name);
    XtDestroyWidget(ipanel->namepopup);
***************
*** 337,342 ****
--- 352,358 ----
      {
        { XtNx, (XtArgVal) 0 },
        { XtNy, (XtArgVal) 0 },
+       { XtNinput, (XtArgVal) True },
      };
    static Arg q[] =
      {
***************
*** 567,573 ****
        tpanel = gi_cur_ipanel;
        gi_set_display_globals(ipanel, False);
      }
!   (void) sprintf(buf, "%s", XtDialogGetValueString(ipanel->namedialog));
    gi_strip(buf);
    if (sscanf(buf,"%d %d", &new_x, &new_y)!=2)
      gi_put_error("Illegal Origin specification");
--- 583,593 ----
        tpanel = gi_cur_ipanel;
        gi_set_display_globals(ipanel, False);
      }
! #ifndef XtSpecificationRelease
!   (void) strcpy(buf, XtDialogGetValueString(ipanel->namedialog));
! #else
!   (void) strcpy(buf, XawDialogGetValueString(ipanel->namedialog));
! #endif /* XtSpecificationRelease */
    gi_strip(buf);
    if (sscanf(buf,"%d %d", &new_x, &new_y)!=2)
      gi_put_error("Illegal Origin specification");
***************
*** 591,596 ****
--- 611,617 ----
      {
        { XtNx, (XtArgVal) 0 },
        { XtNy, (XtArgVal) 0 },
+       { XtNinput, (XtArgVal) True },
      };
    static Arg q[] =
      {
***************
*** 871,877 ****
  
    static Arg a[] =
      {
!       {XtNheight, (XtArgVal) 0 },
        {XtNsensitive, (XtArgVal) TRUE },
        {XtNresizable, (XtArgVal) TRUE },
        {XtNborderWidth, (XtArgVal) 0},
--- 892,903 ----
  
    static Arg a[] =
      {
! #ifndef XtSpecificationRelease
!       {XtNheight,  (XtArgVal) 0 },
! #else
!       {XtNheight,  (XtArgVal) 100 },
!       {XtNwidth,   (XtArgVal) 100 },
! #endif /* XtSpecificationRelease */
        {XtNsensitive, (XtArgVal) TRUE },
        {XtNresizable, (XtArgVal) TRUE },
        {XtNborderWidth, (XtArgVal) 0},
***************
*** 889,894 ****
--- 915,923 ----
      {
        { XtNdefaultDistance, (XtArgVal) 1},
        { XtNborderWidth, (XtArgVal) 0 },
+ #ifdef XtSpecificationRelease
+       { XtNshowGrip, (XtArgVal) False },
+ #endif
      };
    static Arg c[] = 
      {
***************
*** 898,903 ****
--- 927,933 ----
        { XtNheight, (XtArgVal) 0 },
        { XtNdefaultDistance, (XtArgVal) 0},
        { XtNborderWidth, (XtArgVal) 2},
+       { XtNinput, (XtArgVal) True },
      };
    static Arg d[] = 
      {
***************
*** 913,923 ****
--- 943,957 ----
      {
        { XtNdefaultDistance, (XtArgVal) 0},
        { XtNborderWidth, (XtArgVal) 0 },
+ #ifdef XtSpecificationRelease
+       { XtNshowGrip, (XtArgVal) False },
+ #endif
      };
    static Arg f[] =
      {
        { XtNdefaultDistance, (XtArgVal) 0},
        { XtNborderWidth, (XtArgVal) 0 },
+       { XtNinput, (XtArgVal) True },
      };
  
    gi_init_display_globals(ipanel);
***************
*** 929,938 ****
    c[1].value = (XtArgVal) yorig;
    c[2].value = (XtArgVal) width;
    c[3].value = (XtArgVal) height;
!   ipanel->popup = XtCreatePopupShell("display_shell",transientShellWidgetClass,
! 				     gi_tool, c, XtNumber(c));
!   vpane = XtCreateManagedWidget("vpane_box", vPanedWidgetClass, ipanel->popup,
! 				f, XtNumber(f));
    box = XtCreateManagedWidget("form_box", formWidgetClass, vpane, b, XtNumber(b));
  				/* add buttons */
  
--- 963,974 ----
    c[1].value = (XtArgVal) yorig;
    c[2].value = (XtArgVal) width;
    c[3].value = (XtArgVal) height;
!   ipanel->popup = XtCreatePopupShell("display_shell",topLevelShellWidgetClass, gi_tool, c, XtNumber(c));
! #ifndef XtSpecificationRelease
!   vpane = XtCreateManagedWidget("vpane_box", vPanedWidgetClass, ipanel->popup, f, XtNumber(f));
! #else
!   vpane = XtCreateManagedWidget("vpane_box", panedWidgetClass, ipanel->popup, f, XtNumber(f));
! #endif /* XtSpecificationRelease */
    box = XtCreateManagedWidget("form_box", formWidgetClass, vpane, b, XtNumber(b));
  				/* add buttons */
  
***************
*** 951,957 ****
  
  				/* make display panel, add callbacks */
    fbox = XtCreateManagedWidget("display_form", formWidgetClass, vpane, e, XtNumber(e));
!   a[0].value = (XtArgVal) 100;
  
    dbox = XtCreateManagedWidget("display_box", displayWidgetClass, fbox,
  			       a, XtNumber(a));
--- 987,995 ----
  
  				/* make display panel, add callbacks */
    fbox = XtCreateManagedWidget("display_form", formWidgetClass, vpane, e, XtNumber(e));
! #ifndef XtSpecificationRelease
!   a[0].value =  (XtArgVal) 100;
! #endif /* XtSpecificationRelease */
  
    dbox = XtCreateManagedWidget("display_box", displayWidgetClass, fbox,
  			       a, XtNumber(a));
***************
*** 974,982 ****
    XSetFunction(XtDisplay(gi_tool),ipanel->globals.gc, GXcopy);
    XSetFont(XtDisplay(gi_tool), ipanel->globals.gc, gi_default_font.fid);
  
!   /* the next two statements depend on the internals of VPaned.c */
!   XtSetMappedWhenManaged(((Pane)(box->core.constraints))->grip, False);
!   XtSetMappedWhenManaged(((Pane)(fbox->core.constraints))->grip, False);
  
      /* change the cursor on the graphics panel to a crosshair */
    ipanel->globals.last_cursor = gi_main_cursor;
--- 1012,1022 ----
    XSetFunction(XtDisplay(gi_tool),ipanel->globals.gc, GXcopy);
    XSetFont(XtDisplay(gi_tool), ipanel->globals.gc, gi_default_font.fid);
  
! #ifndef XtSpecificationRelease
!   /* the next two statements depend on the internals of VPaned.c... */
!   XtSetMappedWhenManaged(((Pane)(box->core.constraints))->grip,  False);
!   XtSetMappedWhenManaged(((Pane)(fbox->core.constraints))->grip,  False);
! #endif /* XtSpecificationRelease */
  
      /* change the cursor on the graphics panel to a crosshair */
    ipanel->globals.last_cursor = gi_main_cursor;
***************
*** 1268,1273 ****
--- 1308,1318 ----
     static struct grobj *obj_ptr;
     char buf[MAX_ITEM_LENGTH+1];
     char *sptr;
+ #ifndef XtSpecificationRelease
+    XtTextBlock text; 
+ #else
+    XawTextBlock text;
+ #endif /* XtSpecificationRelease */
  
     /*************************************/
     /* mouse has left the display window */ 
***************
*** 1378,1385 ****
            }
      
            /* copy new target/site arg to panel prompt */
! 	  strcpy(gi_target_buf,buf);
! 	  SetValue(gi_mitem[TARGET_ITEM],XtNstring,gi_target_buf);
         }
       }
     }       
--- 1423,1439 ----
            }
      
            /* copy new target/site arg to panel prompt */
! 	  text.firstPos = 0;
! 	  text.format = FMT8BIT;
! 	  text.length = strlen(buf);
! 	  text.ptr = buf;
! #ifndef XtSpecificationRelease
! 	  XtTextReplace(gi_litem[TARGET_ITEM], 0, strlen(gi_target_buf), &text);
! 	  XtTextSetInsertionPoint(gi_mitem[TARGET_ITEM], strlen(buf));
! #else
! 	  XawTextReplace(gi_litem[TARGET_ITEM], 0, strlen(gi_target_buf), &text);
! 	  XawTextSetInsertionPoint(gi_mitem[TARGET_ITEM], strlen(buf));
! #endif /* XtSpecificationRelease */
         }
       }
     }       
***************
*** 1407,1413 ****
    char *site_string;
    int update_prompt;
    int inpos;
!   XtTextBlock text;
  
    /* if ptr is null, then get the pointer, if any,
       to the grobj for that unit
--- 1461,1471 ----
    char *site_string;
    int update_prompt;
    int inpos;
! #ifndef XtSpecificationRelease
!   XtTextBlock text; 
! #else
!   XawTextBlock text;
! #endif /* XtSpecificationRelease */
  
    /* if ptr is null, then get the pointer, if any,
       to the grobj for that unit
***************
*** 1452,1459 ****
      (void) sprintf(buf,"%1d/%s",gi_cur_link_target,site_string);
      text.length = strlen(buf);
      text.ptr = buf;
!     inpos =  XtTextGetInsertionPoint(gi_litem[LSITE_ITEM]);
!     XtTextReplace(gi_litem[LSITE_ITEM], 0, inpos, &text);
    }
  
    /* set the reshow flags appropriately */
--- 1510,1523 ----
      (void) sprintf(buf,"%1d/%s",gi_cur_link_target,site_string);
      text.length = strlen(buf);
      text.ptr = buf;
!     inpos =  strlen(gi_ltarget_buf);
! #ifndef XtSpecificationRelease
!     XtTextReplace(gi_litem[LSITE_ITEM], 0, inpos, &text); 
!     XtTextSetInsertionPoint(gi_mitem[LSITE_ITEM], text.length);
! #else
!     XawTextReplace(gi_litem[LSITE_ITEM], 0, inpos, &text);
!     XawTextSetInsertionPoint(gi_mitem[LSITE_ITEM], text.length);
! #endif /* XtSpecificationRelease */
    }
  
    /* set the reshow flags appropriately */
diff -c -r rcs_dist/src/xgi/gi_cmdfunc.c rcs_v4.2/src/xgi/gi_cmdfunc.c
*** rcs_dist/src/xgi/gi_cmdfunc.c	Tue Sep 26 14:14:31 1989
--- rcs_v4.2/src/xgi/gi_cmdfunc.c	Thu Jun  7 16:25:50 1990
***************
*** 253,259 ****
    if ((unit_index = gi_sim_get_unit(name, GET_FIRST)) == ERROR)
      return (ERROR);
  
!   if (unit_index < 0 || unit_index + num_units >= NoUnits)
      return (ERROR);
  
    /* made it this far; parameters are OK */
--- 253,259 ----
    if ((unit_index = gi_sim_get_unit(name, GET_FIRST)) == ERROR)
      return (ERROR);
  
!   if (unit_index < 0 || unit_index + num_units > NoUnits)
      return (ERROR);
  
    /* made it this far; parameters are OK */
***************
*** 324,330 ****
    if (num_units<0) 
      return(ERROR);
     
!   if (unit_index < 0 || unit_index + num_units >= NoUnits)
      return (ERROR);
  
    /* get what to display (potential, output, etc) */
--- 324,330 ----
    if (num_units<0) 
      return(ERROR);
     
!   if (unit_index < 0 || unit_index + num_units > NoUnits)
      return (ERROR);
  
    /* get what to display (potential, output, etc) */
***************
*** 436,442 ****
    if ((unit_index = gi_sim_get_unit(name, GET_FIRST)) == ERROR)
      return (ERROR);
     
!   if (unit_index < 0 || unit_index + num_units >= NoUnits)
      return (ERROR);
  
    /* made it this far; parameters are OK */
--- 436,442 ----
    if ((unit_index = gi_sim_get_unit(name, GET_FIRST)) == ERROR)
      return (ERROR);
     
!   if (unit_index < 0 || unit_index + num_units > NoUnits)
      return (ERROR);
  
    /* made it this far; parameters are OK */
***************
*** 489,495 ****
    if (num_units<0) 
      return(ERROR);
     
!   if (unit_index < 0 || unit_index + num_units >= NoUnits)
      return (ERROR);
  
    /* get what to display (potential, output, etc) */
--- 489,495 ----
    if (num_units<0) 
      return(ERROR);
     
!   if (unit_index < 0 || unit_index + num_units > NoUnits)
      return (ERROR);
  
    /* get what to display (potential, output, etc) */
***************
*** 552,558 ****
    if (num_units<0) 
      return(ERROR);
     
!   if (unit_index < 0 || unit_index + num_units >= NoUnits)
      return (ERROR);
  
    /* made it this far: parameters are OK */
--- 552,558 ----
    if (num_units<0) 
      return(ERROR);
     
!   if (unit_index < 0 || unit_index + num_units > NoUnits)
      return (ERROR);
  
    /* made it this far: parameters are OK */
diff -c -r rcs_dist/src/xgi/info_panel.c rcs_v4.2/src/xgi/info_panel.c
*** rcs_dist/src/xgi/info_panel.c	Thu Oct 12 12:13:10 1989
--- rcs_v4.2/src/xgi/info_panel.c	Tue Jun 12 13:42:07 1990
***************
*** 29,38 ****
  #include "externs.h"
  #include "panel.h"
  #include "info_panel.h"
! #include <X11/Xmu.h>
! #include <X11/Text.h>
! #include <X11/AsciiText.h>
! #include <X11/Command.h>
  
  /* global declarations */
  info_panel_t gi_info_panel_head;
--- 29,45 ----
  #include "externs.h"
  #include "panel.h"
  #include "info_panel.h"
! #ifndef XtSpecificationRelease
! # include <X11/Xmu.h>
! # include <X11/Text.h>
! # include <X11/AsciiText.h>
! # include <X11/Command.h>
! #else
! # include <X11/Xmu/Xmu.h>
! # include <X11/Xaw/Text.h>
! # include <X11/Xaw/AsciiText.h>
! # include <X11/Xaw/Command.h>
! #endif /* XtSpecificationRelease */
  
  /* global declarations */
  info_panel_t gi_info_panel_head;
***************
*** 146,161 ****
   
    static Arg a[] = 
      {
!       { XtNheight, (XtArgVal) 0 },
!       { XtNstring, (XtArgVal) NULL },
!       { XtNwidth, (XtArgVal) 0 },
!       { XtNeditType, (XtArgVal) XttextEdit },
        { XtNlength, (XtArgVal) 150 },
        { XtNborderWidth, (XtArgVal) 0},
-       { XtNtextOptions, (XtArgVal) (resizeWidth | resizeHeight)},
        { XtNfont, (XtArgVal) &gi_default_font },
        { XtNleft, (XtArgVal) XtChainLeft },
        { XtNright, (XtArgVal) XtChainRight },
      };
    static Arg b[] = 
      {
--- 153,177 ----
   
    static Arg a[] = 
      {
!       { XtNstring,  (XtArgVal) NULL },
!       { XtNheight,  (XtArgVal) 0 },
!       { XtNwidth,  (XtArgVal) 0 },
! #ifndef XtSpecificationRelease
!       { XtNeditType,  (XtArgVal) XttextEdit },
!       { XtNtextOptions,  (XtArgVal) (resizeWidth | resizeHeight)},
! #else
!       { XtNuseStringInPlace, (XtArgVal) True },
!       { XtNtype, (XtArgVal) XawAsciiString },
!       { XtNeditType, (XtArgVal) XawtextEdit },
!       { XtNresize, (XtArgVal) XawtextResizeBoth },
!       { XtNwrap, (XtArgVal) XawtextWrapNever },
! #endif /* XtSpecificationRelease */
        { XtNlength, (XtArgVal) 150 },
        { XtNborderWidth, (XtArgVal) 0},
        { XtNfont, (XtArgVal) &gi_default_font },
        { XtNleft, (XtArgVal) XtChainLeft },
        { XtNright, (XtArgVal) XtChainRight },
+       { XtNresizable, (XtArgVal) True },
      };
    static Arg b[] = 
      {
***************
*** 170,175 ****
--- 186,193 ----
      {
        { XtNx, (XtArgVal) 0 },
        { XtNy, (XtArgVal) 0 },
+       { XtNinput, (XtArgVal) True },
+       { XtNallowShellResize, (XtArgVal) True },
      };
    static Arg d[] = 
      {
***************
*** 188,204 ****
  
    ipanel = (info_panel_t)malloc(sizeof(*ipanel));
    c[0].value = (XtArgVal) index*8;
!   ipanel->popup = XtCreatePopupShell("info_shell",transientShellWidgetClass,
! 				     gi_tool,c, XtNumber(c));
    box = XtCreateManagedWidget("info_box", formWidgetClass, ipanel->popup,
  			      form_args, XtNumber(form_args));
-   a[0].value = (XtArgVal) 11 * (gi_default_font.max_bounds.ascent +
- 			       gi_default_font.max_bounds.descent);
    strcpy(ipanel->buf, blank_info_format); 
!   a[1].value = (XtArgVal) ipanel->buf;
    a[2].value = (XtArgVal) XTextWidth(&gi_default_font, wmsg, strlen(wmsg));
!   ipanel->text = XtCreateManagedWidget("IPANEL",asciiStringWidgetClass,
! 				       box, a, XtNumber(a));
    b[0].value = (XtArgVal) ipanel->text;
    button = XtCreateManagedWidget("CLOSE", commandWidgetClass, box, b, XtNumber(b));
    XtAddCallback(button, XtNcallback, close_info, ipanel);
--- 206,224 ----
  
    ipanel = (info_panel_t)malloc(sizeof(*ipanel));
    c[0].value = (XtArgVal) index*8;
!   ipanel->popup = XtCreatePopupShell("info_shell",transientShellWidgetClass, gi_tool,c, XtNumber(c));
    box = XtCreateManagedWidget("info_box", formWidgetClass, ipanel->popup,
  			      form_args, XtNumber(form_args));
    strcpy(ipanel->buf, blank_info_format); 
!   a[0].value = (XtArgVal) ipanel->buf;
!   a[1].value = (XtArgVal) 11 * (gi_default_font.max_bounds.ascent +
! 			       gi_default_font.max_bounds.descent);
    a[2].value = (XtArgVal) XTextWidth(&gi_default_font, wmsg, strlen(wmsg));
! #ifndef XtSpecificationRelease
!   ipanel->text = XtCreateManagedWidget("IPANEL", asciiStringWidgetClass, box, a, XtNumber(a));
! #else
!   ipanel->text = XtCreateManagedWidget("IPANEL", asciiTextWidgetClass, box, a, XtNumber(a));
! #endif /* XtSpecificationRelease */
    b[0].value = (XtArgVal) ipanel->text;
    button = XtCreateManagedWidget("CLOSE", commandWidgetClass, box, b, XtNumber(b));
    XtAddCallback(button, XtNcallback, close_info, ipanel);
***************
*** 269,275 ****
    int bold_flag[DATA+1];
  #endif
    int i;
!   XtTextBlock text;
    char buf[190];
    struct info_unit *iu;
  
--- 289,299 ----
    int bold_flag[DATA+1];
  #endif
    int i;
! #ifndef XtSpecificationRelease
!   XtTextBlock text; 
! #else
!   XawTextBlock text;
! #endif /* XtSpecificationRelease */
    char buf[190];
    struct info_unit *iu;
  
***************
*** 302,319 ****
  	      iu->ui, iu->name, iu->type, iu->pot,
  	      iu->out, iu->state, iu->data);
      }
-   for (i = strlen(buf); i <= strlen(ip->buf); i++)
-     buf[i] = ' ';
-   buf[i] = '\0';
  
    text.firstPos = 0;
!   text.length = strlen(ip->buf);
    text.ptr = buf;
    text.format = FMT8BIT;
    
!   XtTextReplace(ip->text, 0, strlen(ip->buf), &text);
!   ForceBuildLineTable(ip->text);   /* grepped from X11/lib/Xaw/Text.c */
!   XtTextDisplay(ip->text);
  }
  
  /*************************************************************************/
--- 326,345 ----
  	      iu->ui, iu->name, iu->type, iu->pot,
  	      iu->out, iu->state, iu->data);
      }
  
    text.firstPos = 0;
!   text.length = strlen(buf);
    text.ptr = buf;
    text.format = FMT8BIT;
    
! #ifndef XtSpecificationRelease
!   XtTextReplace(ip->text, 0, strlen(ip->buf), &text); 
!   ForceBuildLineTable(ip->text);   	/* grepped from X11/lib/Xaw/Text.c */
!   XtTextDisplay(ip->text); 
! #else
!   XawTextReplace(ip->text, 0, strlen(ip->buf), &text);
!   XawTextDisplay(ip->text);
! #endif /* XtSpecificationRelease */
  }
  
  /*************************************************************************/
***************
*** 473,477 ****
  	  iu->out, iu->state, iu->data,
  	  iu->link, iu->target);
  }
! 	
  
--- 499,503 ----
  	  iu->out, iu->state, iu->data,
  	  iu->link, iu->target);
  }
! 
  
diff -c -r rcs_dist/src/xgi/main.c rcs_v4.2/src/xgi/main.c
*** rcs_dist/src/xgi/main.c	Tue Sep 26 14:13:32 1989
--- rcs_v4.2/src/xgi/main.c	Tue Jun 12 13:42:53 1990
***************
*** 31,38 ****
  #include "panel.h"
  #include "control_panel.h"
  #include "info_panel.h"
! #include <X11/Box.h>
! #include <X11/VPaned.h>
  #include <X11/Xlib.h>
  
  #undef DEBUG
--- 31,43 ----
  #include "panel.h"
  #include "control_panel.h"
  #include "info_panel.h"
! #ifndef XtSpecificationRelease
! # include <X11/Box.h>
! # include <X11/VPaned.h>
! #else
! # include <X11/Xaw/Box.h>
! # include <X11/Xaw/Paned.h>
! #endif /* XtSpecificationRelease */
  #include <X11/Xlib.h>
  
  #undef DEBUG
***************
*** 162,168 ****
      exit(1);
    }
  
!   gi_tool = XtCreateManagedWidget("GI_TOOL", vPanedWidgetClass, shell, NULL, 0);
  
     /* get default font resource */
    if ((fontname = XGetDefault(XtDisplay(gi_tool), argv[0], "font")) == NULL)
--- 167,177 ----
      exit(1);
    }
  
! #ifndef XtSpecificationRelease
!   gi_tool =  XtCreateManagedWidget("GI_TOOL", vPanedWidgetClass, shell, NULL, 0);
! #else
!   gi_tool =  XtCreateManagedWidget("GI_TOOL", panedWidgetClass, shell, NULL, 0);
! #endif /* XtSpecificationRelease */
  
     /* get default font resource */
    if ((fontname = XGetDefault(XtDisplay(gi_tool), argv[0], "font")) == NULL)
diff -c -r rcs_dist/src/xgi/misc.c rcs_v4.2/src/xgi/misc.c
*** rcs_dist/src/xgi/misc.c	Tue Sep 26 14:13:44 1989
--- rcs_v4.2/src/xgi/misc.c	Tue Jun 12 13:43:31 1990
***************
*** 1218,1224 ****
  /* updates the position of the marker
   * on the control panel
   */
!   XtTextBlock text;
    int inpos;
    static char markx[MAX_NUM_LENGTH+1], marky[MAX_NUM_LENGTH+1];
  
--- 1218,1228 ----
  /* updates the position of the marker
   * on the control panel
   */
! #ifndef XtSpecificationRelease
!   XtTextBlock text; 
! #else
!   XawTextBlock text;
! #endif
    int inpos;
    static char markx[MAX_NUM_LENGTH+1], marky[MAX_NUM_LENGTH+1];
  
***************
*** 1230,1242 ****
  
    text.length = strlen(markx);
    text.ptr = markx;
!   inpos =  XtTextGetInsertionPoint(gi_mitem[WHEREX_ITEM]);
!   XtTextReplace(gi_mitem[WHEREX_ITEM], 0, inpos, &text);
  
    text.length = strlen(marky);
    text.ptr = marky;
!   inpos =  XtTextGetInsertionPoint(gi_mitem[WHEREY_ITEM]);
!   XtTextReplace(gi_mitem[WHEREY_ITEM], 0, inpos, &text);
  }
  
  /*************************************************************************/
--- 1234,1258 ----
  
    text.length = strlen(markx);
    text.ptr = markx;
!   inpos = strlen(gi_wherex_buf);
! #ifndef XtSpecificationRelease
!   XtTextReplace(gi_mitem[WHEREX_ITEM], 0, inpos, &text); 
!   XtTextSetInsertionPoint(gi_mitem[WHEREX_ITEM], text.length);
! #else
!   XawTextReplace(gi_mitem[WHEREX_ITEM], 0, inpos, &text);
!   XawTextSetInsertionPoint(gi_mitem[WHEREX_ITEM], text.length);
! #endif /* XtSpecificationRelease */
  
    text.length = strlen(marky);
    text.ptr = marky;
!   inpos = strlen(gi_wherey_buf);
! #ifndef XtSpecificationRelease
!   XtTextReplace(gi_mitem[WHEREY_ITEM], 0, inpos, &text); 
!   XtTextSetInsertionPoint(gi_mitem[WHEREY_ITEM], text.length);
! #else
!   XawTextReplace(gi_mitem[WHEREY_ITEM], 0, inpos, &text);
!   XawTextSetInsertionPoint(gi_mitem[WHEREY_ITEM], text.length);
! #endif /* XtSpecificationRelease */
  }
  
  /*************************************************************************/
diff -c -r rcs_dist/src/xgi/mode_panel.c rcs_v4.2/src/xgi/mode_panel.c
*** rcs_dist/src/xgi/mode_panel.c	Tue Sep 26 14:01:38 1989
--- rcs_v4.2/src/xgi/mode_panel.c	Tue Jun 12 12:54:06 1990
***************
*** 30,36 ****
  #include "externs.h"
  #include "panel.h"
  #include "control_panel.h"
! #include <X11/Xmu.h>
  
  extern char gi_logfile_name[];
  
--- 30,40 ----
  #include "externs.h"
  #include "panel.h"
  #include "control_panel.h"
! #ifndef XtSpecificationRelease
! # include <X11/Xmu.h>
! #else
! # include <X11/Xmu/Xmu.h>
! #endif /* XtSpecificationRelease */
  
  extern char gi_logfile_name[];
  
diff -c -r rcs_dist/src/xgi/msg_panel.c rcs_v4.2/src/xgi/msg_panel.c
*** rcs_dist/src/xgi/msg_panel.c	Tue Sep 26 14:14:06 1989
--- rcs_v4.2/src/xgi/msg_panel.c	Tue Jun 12 12:54:24 1990
***************
*** 25,33 ****
  #include "macros.h"
  #include "externs.h"
  #include "panel.h"
! #include <X11/Xmu.h>
! #include <X11/Form.h>
! #include <X11/Label.h>
  
  #undef DEBUG
  
--- 25,39 ----
  #include "macros.h"
  #include "externs.h"
  #include "panel.h"
! #ifndef XtSpecificationRelease
! # include <X11/Xmu.h>
! # include <X11/Form.h>
! # include <X11/Label.h>
! #else
! # include <X11/Xmu/Xmu.h>
! # include <X11/Xaw/Form.h>
! # include <X11/Xaw/Label.h>
! #endif /* XtSpecificationRelease */
  
  #undef DEBUG
  

-------------------------------------------------------------------------------
